<?php 
// Klassen-Datei "LesenSchueler.class.php"

/*
 Klasse zum Lesen von Datenstzen fr Instanzen der Klasse SCHUELER
 (Schlerdatei fr die bungen A03, A07, A08, A09, A10, A11, A25 und A26)
 -------------------------------------------------------------------------------
 @module  Fachbuch "Programmierlogik"
 @since   August 2008
 @version August 2009
 @author  Beringer Alfred
 *******************************************************************************
*/
class LesenSchueler
{
    // -------------------------------------------------------------------------
    // Klassenvariable
    // -------------------------------------------------------------------------

    const SATZLAENGE = 80;
  
    private static $FELDLAENGE = array("fn" =>20,
                                       "vn" =>10,
                                       "g"  => 1,
                                       "gd" => 8,
                                       "rel"=> 2,
                                       "st" => 3,
                                       "kl" => 5,
                                       "plz"=> 4,
                                       "ort"=>12,
                                       "str"=>15);

    // -------------------------------------------------------------------------
    // Instanzvariable
    // -------------------------------------------------------------------------

    private $datei;
    private $eof;

    private $schueler;

    // -------------------------------------------------------------------------
    // Get-/Set-Methoden
    // -------------------------------------------------------------------------

    public function getEof()
    {
        return $this->eof;
    }

    // -----

    public function getSchueler()
    {
        return $this->schueler;
    }

    // -------------------------------------------------------------------------
    // Instanzmethoden
    // -------------------------------------------------------------------------

    public function oeffnen($dateiname)
    {
        $this->datei = fopen($dateiname, "rb") 
                  or die("<p>Die Datei <b>$dateiname</b> existiert nicht.</p>");
    }

    // -------------------------------------------------------------------------

    public function lesen()
    {
        $this->schueler = new Schueler();
        $datensatz = fread($this->datei, self::SATZLAENGE);
        $this->eof = feof($this->datei);
        $this->aufbereitenDatensatz($datensatz);
        return $this->schueler;
    }

    // -------------------------------------------------------------------------

    public function schliessen()
    {
        fclose($this->datei);
    }

    /*
     Diese Methode bereitet einen Datensatz auf, in dem alle Attribute eines 
     Schlerobjekts nebeneinander ohne Abstand gespeichert sind.
     Alle Attribute haben eine fixe Lnge.
    */
    public function aufbereitenDatensatz($datensatz)
    {
        $offset = 0;
        $this->schueler->setFn( substr($datensatz, $offset, self::$FELDLAENGE["fn"]));
                               $offset += self::$FELDLAENGE["fn"];
        $this->schueler->setVn( substr($datensatz, $offset, self::$FELDLAENGE["vn"]));
                               $offset += self::$FELDLAENGE["vn"];
        $this->schueler->setG(  substr($datensatz, $offset, self::$FELDLAENGE["g"]));
                               $offset += self::$FELDLAENGE["g"];
        $this->schueler->setGd( substr($datensatz, $offset, self::$FELDLAENGE["gd"]));
                               $offset += self::$FELDLAENGE["gd"];
        $this->schueler->setRel(substr($datensatz, $offset, self::$FELDLAENGE["rel"]));
                               $offset += self::$FELDLAENGE["rel"];
        $this->schueler->setSt( substr($datensatz, $offset, self::$FELDLAENGE["st"]));
                               $offset += self::$FELDLAENGE["st"];
        $this->schueler->setKl( substr($datensatz, $offset, self::$FELDLAENGE["kl"]));
                               $offset += self::$FELDLAENGE["kl"];
        $this->schueler->setPlz(substr($datensatz, $offset, self::$FELDLAENGE["plz"]));
                               $offset += self::$FELDLAENGE["plz"];
        $this->schueler->setOrt(substr($datensatz, $offset, self::$FELDLAENGE["ort"]));
                               $offset += self::$FELDLAENGE["ort"];
        $this->schueler->setStr(substr($datensatz, $offset, self::$FELDLAENGE["str"]));
    }
}
?>
