<?php 
// Include-Datei "artikelCbinaer.inc.php"

/*
 *******************************************************************************
 Datei ALTBAND
 (bungen A39, A40, A41 und A42)

   Achtung:
        Satzlnge Artikel = 51 + 3 = 54 (3 binre Nullen);
        aber wegen Alignment des float-Feldes kommen noch 2 Slack-Bytes
        hinzu (vor 'bpreis').
        Daher ist die tatschliche Satzlnge = 56!
 -------------------------------------------------------------------------------
 @module  Fachbuch "Programmierlogik"
 @since   August 2009
 @author  Beringer Alfred
 *******************************************************************************
*/

const SATZLAENGEALTBAND = 56;

/*
 1 Datensatz wird in seine Einzelfelder zerlegt und - als Datenstruktur 
 aufbereitet - zurckgegeben.
 
 Parameter:  string $datensatz:  Datensatz als Zeichenkette
 
 return:  struct $eber:  Datensatz als Datenstruktur mit allen Datenfeldern 
                         (Eingabebereich)
*/
function aufbereitenDatensatzAltband($datensatz)
{
    $feldlaenge = array("bnr"   => 5,
                        "bbez"  =>21,
                        "slack1"=> 2,      // Slackbytes
                        "bpreis"=> 4,      // float
                        "bbmeng"=> 4,      // int
                        "bsonst"=>20);

    $offset = 0;
    $eber->bnr    = substr($datensatz,$offset,$feldlaenge["bnr"]-1);
    $offset += $feldlaenge["bnr"];
    $eber->bbez   = substr($datensatz,$offset,$feldlaenge["bbez"]-1);
    $offset += $feldlaenge["bbez"];
    $offset += $feldlaenge["slack1"];
    $preis        = substr($datensatz,$offset,$feldlaenge["bpreis"]);
    $offset += $feldlaenge["bpreis"];
    $bmeng        = substr($datensatz,$offset,$feldlaenge["bbmeng"]);
    $offset += $feldlaenge["bbmeng"];
    $eber->bsonst = substr($datensatz,$offset,$feldlaenge["bsonst"]-1);

    $eberstr = unpack("fepreis", $preis);
    $eber->epreis = $eberstr["epreis"];
    $eberstr = unpack("iebmeng", $bmeng);
    $eber->ebmeng = $eberstr["ebmeng"];

    return $eber;
}

/*
 1 Datensatz (als Datenstruktur) wird in eine Zeichenkette konvertiert, wobei 
 die Lngen der numerischen Datenfelder fix definiert werden.
 
 Parameter:  struct $eber:  Datensatz als Datenstruktur
 
 return:  string $str:  Datensatz als Zeichenkette
*/
function toStringAltband($eber)
{
//    $eber->bpreis = $eber->bpreis * 100;             // 2 Nachkommastellen
    $NULLBYTE = pack("x");
    $slack1 =  $NULLBYTE . $NULLBYTE;
    $preis = pack("f", $eber->bpreis);
    $bmeng = pack("i", $eber->bbmeng);

    $str = $eber->bnr . $NULLBYTE . $eber->bbez . $NULLBYTE . $slack1 . $preis . $bmeng . $eber->bsonst . $NULLBYTE;

    return $str;
}
?>
