<?php 
// Include-Datei "kaenderCbinaer.inc.php"

/*
 *******************************************************************************
 Datei KAENDER
 (bung A39)

   Achtung:
        Satzlnge Kaender = 8 + 1 = 9 (1 binre Null);
        aber wegen Alignment des float-Feldes kommen noch 3 Slack-Bytes
        hinzu (vor 'kpreis').
        Daher ist die tatschliche Satzlnge = 12!
 -------------------------------------------------------------------------------
 @module  Fachbuch "Programmierlogik"
 @since   August 2009
 @author  Beringer Alfred
 *******************************************************************************
*/

const SATZLAENGEKAENDER = 12;

/*
 1 Datensatz wird in seine Einzelfelder zerlegt und - als Datenstruktur 
 aufbereitet - zurckgegeben.
 
 Parameter:  string $datensatz:  Datensatz als Zeichenkette
 
 return:  struct $eber:  Datensatz als Datenstruktur mit allen Datenfeldern 
                         (Eingabebereich)
*/
function aufbereitenDatensatzKaender($datensatz)
{
    $feldlaenge = array("knr"   => 5,
                        "slack1"=> 3,      // Slackbytes
                        "kpreis"=> 4);     // float

    $offset = 0;
    $eber->knr    = substr($datensatz,$offset,$feldlaenge["knr"]-1);
    $offset += $feldlaenge["knr"];
    $offset += $feldlaenge["slack1"];
    $preis        = substr($datensatz,$offset,$feldlaenge["kpreis"]);

    $eberstr = unpack("fepreis", $preis);
    $eber->epreis = $eberstr["epreis"];

    return $eber;
}
?>
