<?php 
// Include-Datei "kostenCbinaer.inc.php"

/*
 *******************************************************************************
 Datei KOSTEN
 (bung A27)

   Achtung:
        Satzlnge Kosten = 8 + 2 = 10 (2 binre Nullen);
        aber wegen Alignment des float-Feldes kommen noch 2 Slack-Bytes
        hinzu (vor 'ebet').
        Daher ist die tatschliche Satzlnge = 12!
 -------------------------------------------------------------------------------
 @module  Fachbuch "Programmierlogik"
 @since   August 2009
 @author  Beringer Alfred
 *******************************************************************************
*/

const SATZLAENGE = 12;

/*
 1 Datensatz wird in seine Einzelfelder zerlegt und - als Datenstruktur 
 aufbereitet - zurckgegeben.
 
 Parameter:  string $datensatz:  Datensatz als Zeichenkette
 
 return:  struct $eber:  Datensatz als Datenstruktur mit allen Datenfeldern 
                         (Eingabebereich)
*/
function aufbereitenDatensatz($datensatz)
{
    $feldlaenge = array("ekst"  => 3,
                        "eka"   => 3,
                        "slack1"=> 2,      // Slackbytes
                        "ebet"  => 4);     // float

    $offset = 0;
    $eber->ekst = substr($datensatz,$offset,$feldlaenge["ekst"]-1);
    $offset += $feldlaenge["ekst"];
    $eber->eka  = substr($datensatz,$offset,$feldlaenge["eka"]-1);
    $offset += $feldlaenge["eka"];
    $offset += $feldlaenge["slack1"];
    $bet        = substr($datensatz,$offset,$feldlaenge["ebet"]);

    $eberstr = unpack("febet", $bet);
    $eber->ebet = $eberstr["ebet"];

    return $eber;
}
?>
