<?php 
// Include-Datei "kundenCbinaer.inc.php"

/*
 *******************************************************************************
 Datei KUNDEN
 (bung A12)

   Achtung:
        Satzlnge Kunden = 30 + 2 = 32 (2 binre Nullen);
        aber wegen Alignment des float-Feldes kommen noch 4 Slack-Bytes
        hinzu (1 vor 'eums' und 3 am Satzende?!).
        Daher ist die tatschliche Satzlnge = 36!
 -------------------------------------------------------------------------------
 @module  Fachbuch "Programmierlogik"
 @since   August 2009
 @author  Beringer Alfred
 *******************************************************************************
*/

const SATZLAENGE = 36;

/*
 1 Datensatz wird in seine Einzelfelder zerlegt und - als Datenstruktur 
 aufbereitet - zurckgegeben.
 
 Parameter:  string $datensatz:  Datensatz als Zeichenkette
 
 return:  struct $eber:  Datensatz als Datenstruktur mit allen Datenfeldern 
                         (Eingabebereich)
*/
function aufbereitenDatensatz($datensatz)
{
    $feldlaenge = array("enr"   => 5,
                        "enam"  =>21,
                        "eschl" => 1,      // char
                        "slack1"=> 1,      // Slackbytes
                        "eums"  => 4,      // float
                        "esa"   => 1,      // char
                        "slack2"=> 3);     // Slackbytes

    $offset = 0;
    $eber->enr   = substr($datensatz,$offset,$feldlaenge["enr"]-1);
    $offset += $feldlaenge["enr"];
    $eber->enam  = substr($datensatz,$offset,$feldlaenge["enam"]-1);
    $offset += $feldlaenge["enam"];
    $eber->eschl = substr($datensatz,$offset,$feldlaenge["eschl"]);
    $offset += $feldlaenge["eschl"];
    $offset += $feldlaenge["slack1"];
    $ums         = substr($datensatz,$offset,$feldlaenge["eums"]);
    $offset += $feldlaenge["eums"];
    $eber->esa   = substr($datensatz,$offset,$feldlaenge["esa"]);
//    noch 3 Slackbytes am Ende (werden nicht gebraucht)

    $eberstr = unpack("feums", $ums);
    $eber->eums = $eberstr["eums"];

    return $eber;
}
?>
