<?php 
// Include-Datei "steuerCbinaer.inc.php"

/*
 *******************************************************************************
 Datei STEUER
 (bung A28)

   Achtung:
        Satzlnge Steuer = 31 + 3 = 34 (3 binre Nullen);
        aber wegen Alignment des float-Feldes kommen noch 2 Slack-Bytes
        hinzu (vor 'esta').
        Daher ist die tatschliche Satzlnge = 36!
 -------------------------------------------------------------------------------
 @module  Fachbuch "Programmierlogik"
 @since   August 2009
 @author  Beringer Alfred
 *******************************************************************************
*/

const SATZLAENGE = 36;

/*
 1 Datensatz wird in seine Einzelfelder zerlegt und - als Datenstruktur 
 aufbereitet - zurckgegeben.
 
 Parameter:  string $datensatz:  Datensatz als Zeichenkette
 
 return:  struct $eber:  Datensatz als Datenstruktur mit allen Datenfeldern 
                         (Eingabebereich)
*/
function aufbereitenDatensatz($datensatz)
{
    $feldlaenge = array("ebl"   => 1,      // char
                        "ebez"  => 3,
                        "egnam" =>21,
                        "egem"  => 5,
                        "slack1"=> 2,      // Slackbytes
                        "esta"  => 4);     // float

    $offset = 0;
    $eber->ebl   = substr($datensatz,$offset,$feldlaenge["ebl"]);
    $offset += $feldlaenge["ebl"];
    $eber->ebez  = substr($datensatz,$offset,$feldlaenge["ebez"]-1);
    $offset += $feldlaenge["ebez"];
    $eber->egnam = substr($datensatz,$offset,$feldlaenge["egnam"]-1);
    $offset += $feldlaenge["egnam"];
    $eber->egem  = substr($datensatz,$offset,$feldlaenge["egem"]-1);
    $offset += $feldlaenge["egem"];
    $offset += $feldlaenge["slack1"];
    $sta         = substr($datensatz,$offset,$feldlaenge["esta"]);

    $eberstr = unpack("festa", $sta);
    $eber->esta = $eberstr["esta"];

    return $eber;
}
?>
