<?php 
// Include-Datei "stromCbinaer.inc.php"

/*
 *******************************************************************************
 Datei STROM
 (bungen A33 und A35)

   Achtung:
        Satzlnge Strom = 77 + 3 = 80 (3 binre Nullen);
        (zufllig kein Alignment der long-int-Felder).
        Daher bleibt die tatschliche Satzlnge = 80!
 -------------------------------------------------------------------------------
 @module  Fachbuch "Programmierlogik"
 @since   August 2009
 @author  Beringer Alfred
 *******************************************************************************
*/

const SATZLAENGE = 80;

/*
 1 Datensatz wird in seine Einzelfelder zerlegt und - als Datenstruktur 
 aufbereitet - zurckgegeben.
 
 Parameter:  string $datensatz:  Datensatz als Zeichenkette
 
 return:  struct $eber:  Datensatz als Datenstruktur mit allen Datenfeldern 
                         (Eingabebereich)
*/
function aufbereitenDatensatz($datensatz)
{
    $feldlaenge = array("eanr"  => 8,
                        "eznr"  => 8,
                        "ezsalt"=> 4,      // int
                        "ezsneu"=> 4,      // int
                        "esonst"=>55,
                        "eta"   => 1);     // char

    $offset = 0;
    $eber->eanr   = substr($datensatz,$offset,$feldlaenge["eanr"]-1);
    $offset += $feldlaenge["eanr"];
    $eber->eznr   = substr($datensatz,$offset,$feldlaenge["eznr"]-1);
    $offset += $feldlaenge["eznr"];
    $zsalt        = substr($datensatz,$offset,$feldlaenge["ezsalt"]);
    $offset += $feldlaenge["ezsalt"];
    $zsneu        = substr($datensatz,$offset,$feldlaenge["ezsneu"]);
    $offset += $feldlaenge["ezsneu"];
    $eber->esonst = substr($datensatz,$offset,$feldlaenge["esonst"]-1);
    $offset += $feldlaenge["esonst"];
    $eber->eta    = substr($datensatz,$offset,$feldlaenge["eta"]);

    $eberstr = unpack("iezsalt", $zsalt);
    $eber->ezsalt = $eberstr["ezsalt"];
    $eberstr = unpack("iezsneu", $zsneu);
    $eber->ezsneu = $eberstr["ezsneu"];

    return $eber;
}
?>
