<?php 
// Include-Datei "theaterCbinaer.inc.php"

/*
 *******************************************************************************
 Datei THEATER
 (bung A38)

   Achtung:
        Satzlnge Theater = 119 + 6 = 125 (6 binre Nullen);
        aber wegen Alignment des float-Feldes kommen noch 3 Slack-Bytes
        hinzu (1 vor 'ezuschlag' und 2 am Satzende?!).
        Daher ist die tatschliche Satzlnge = 128!
 -------------------------------------------------------------------------------
 @module  Fachbuch "Programmierlogik"
 @since   August 2009
 @author  Beringer Alfred
 *******************************************************************************
*/

const SATZLAENGE = 128;

/*
 1 Datensatz wird in seine Einzelfelder zerlegt und - als Datenstruktur 
 aufbereitet - zurckgegeben.
 
 Parameter:  string $datensatz:  Datensatz als Zeichenkette
 
 return:  struct $eber:  Datensatz als Datenstruktur mit allen Datenfeldern 
                         (Eingabebereich)
*/
function aufbereitenDatensatz($datensatz)
{
    $feldlaenge = array("ekennz"   => 1,      // char
                        "estueck"  =>40,
                        "ename"    =>21,
                        "estamm"   =>16,
                        "ekat"     => 1,      // char
                        "slack1"   => 1,      // Slackbytes
                        "ezuschlag"=> 4,      // float
                        "erolle"   =>24,
                        "eprdat"   => 9,
                        "eldat"    => 9,
                        "slack2"   => 2);     // Slackbytes

    $offset = 0;
    $eber->ekennz    = substr($datensatz,$offset,$feldlaenge["ekennz"]);
    $offset += $feldlaenge["ekennz"];
    $eber->estueck   = substr($datensatz,$offset,$feldlaenge["estueck"]-1);
    $offset += $feldlaenge["estueck"];
    $eber->ename     = substr($datensatz,$offset,$feldlaenge["ename"]-1);
    $offset += $feldlaenge["ename"];
    $eber->estamm    = substr($datensatz,$offset,$feldlaenge["estamm"]-1);
    $offset += $feldlaenge["estamm"];
    $eber->ekat      = substr($datensatz,$offset,$feldlaenge["ekat"]);
    $offset += $feldlaenge["ekat"];
    $offset += $feldlaenge["slack1"];
    $zuschlag        = substr($datensatz,$offset,$feldlaenge["ezuschlag"]);
    $offset += $feldlaenge["ezuschlag"];
    $eber->erolle    = substr($datensatz,$offset,$feldlaenge["erolle"]-1);
    $offset += $feldlaenge["erolle"];
    $eber->eprdat    = substr($datensatz,$offset,$feldlaenge["eprdat"]-1);
    $offset += $feldlaenge["eprdat"];
    $eber->eldat     = substr($datensatz,$offset,$feldlaenge["eldat"]-1);
//    noch 2 Slackbytes am Ende (werden nicht gebraucht)

    $eberstr = unpack("fezuschlag", $zuschlag);
    $eber->ezuschlag = $eberstr["ezuschlag"];

    return $eber;
}
?>
