<?php 
// Include-Datei "vertretA3637Cbinaer.inc.php"

/*
 *******************************************************************************
 Datei VERTRET
 (bung A36 und A37)

        Satzlnge VertretA3637 = 8 (keine binren Nullen);
        (kein Alignment der short-int/float-Felder).
        Daher bleibt die tatschliche Satzlnge = 8!
 -------------------------------------------------------------------------------
 @module  Fachbuch "Programmierlogik"
 @since   August 2009
 @author  Beringer Alfred
 *******************************************************************************
*/

const SATZLAENGE = 8;

/*
 1 Datensatz wird in seine Einzelfelder zerlegt und - als Datenstruktur 
 aufbereitet - zurckgegeben.

 Bem.: Da die Daten mit einem C-Programm unter Windows erstellt wurden, ist der 
       Inhalt eines int-Feldes ein duales Format mit Little-Endian-Darstellung 
       und der Inhalt eines float-Feldes ein Intel-Gleitkommaformat (ebenfalls 
       mit Little-Endian-Darstellung)!
       Die PHP-Funktionen 'settype', 'doubleval', 'floatval' und 'intval' 
       liefern bei der Konvertierung immer den Wert 0!
 
       Formatelemente von unpack:
          v ... vorzeichenloser Short-Typ (immer 16 Bit, Little Endian)
          f ... Gleitkommazahl (maschinenabhngige Gre und Wiedergabe)
 Parameter:  string $datensatz:  Datensatz als Zeichenkette
 
 return:  struct $eber:  Datensatz als Datenstruktur mit allen Datenfeldern 
                         (Eingabebereich)
*/
function aufbereitenDatensatz($datensatz)
{
/*
    $feldlaenge = array("evnr"  => 2,      // short (LittleEndian)
                        "emonat"=> 2,      // short (LittleEndian)
                        "eums"  => 4);     // float (LittleEndian)
*/
    $eberstr = unpack("vevnr/vemonat/feums", $datensatz);

    $eber->evnr   = $eberstr["evnr"];
    $eber->emonat = $eberstr["emonat"];
    $eber->eums   = $eberstr["eums"];

    return $eber;
}
?>
