<?php 
// Include-Datei "vertretCbinaer.inc.php"

/*
 *******************************************************************************
 Datei VERTRET
 (bungen A04, A05 und A15)

   Achtung:
        Satzlnge Vertreter = 39 + 2 = 41 (2 binre Nullen);
        aber wegen Alignment des float-Feldes kommen noch 3 Slack-Bytes
        hinzu (vor eums).
        Daher ist die tatschliche Satzlnge = 44!
 -------------------------------------------------------------------------------
 @module  Fachbuch "Programmierlogik"
 @since   August 2009
 @author  Beringer Alfred
 *******************************************************************************
*/

const SATZLAENGE = 44;

/*
 1 Datensatz wird in seine Einzelfelder zerlegt und - als Datenstruktur 
 aufbereitet - zurckgegeben.
 
 Parameter:  string $datensatz:  Datensatz als Zeichenkette
 
 return:  struct $eber:  Datensatz als Datenstruktur mit allen Datenfeldern 
                         (Eingabebereich)
*/
function aufbereitenDatensatz($datensatz)
{
    $feldlaenge = array("enr"   => 7,
                        "enam"  =>30,
                        "slack1"=> 3,      // Slackbytes
                        "eums"  => 4);     // float

    $offset = 0;
    $eber->enr  = substr($datensatz,$offset,$feldlaenge["enr"]-1);
    $offset += $feldlaenge["enr"];
    $eber->enam = substr($datensatz,$offset,$feldlaenge["enam"]-1);
    $offset += $feldlaenge["enam"];
    $offset += $feldlaenge["slack1"];
    $ums        = substr($datensatz,$offset,$feldlaenge["eums"]);

    $eberstr = unpack("feums", $ums);
    $eber->eums = $eberstr["eums"];

    return $eber;
}
?>
