<?php 
// Include-Datei "zahlenCbinaer.inc.php"

/*
 *******************************************************************************
 Datei ZAHLEN
 (bung A17)

   Achtung:
        Satzlnge Zahlen = 3 * 4B (long int) = 12;
 -------------------------------------------------------------------------------
 @module  Fachbuch "Programmierlogik"
 @since   August 2009
 @author  Beringer Alfred
 *******************************************************************************
*/

const SATZLAENGE = 12;

/*
 1 Datensatz wird in seine Einzelfelder zerlegt und - als Datenstruktur 
 aufbereitet - zurckgegeben.

 Bem.: Da die Daten mit einem C-Programm unter Windows erstellt wurden, ist der 
       Inhalt eines int-Feldes ein duales Format mit Little-Endian-Darstellung 
       und der Inhalt eines float-Feldes ein Intel-Gleitkommaformat (ebenfalls 
       mit Little-Endian-Darstellung)!
       Die PHP-Funktionen 'settype', 'doubleval', 'floatval' und 'intval' 
       liefern bei der Konvertierung immer den Wert 0!
 
       Formatelemente von unpack:
          i ... vorzeichenbehaftete Ganzzahl (Gre und Byte-Folge maschinenabhngig)
          I ... vorzeichenlose Ganzzahl (Gre und Byte-Folge maschinenabhngig)
          l ... vorzeichenbehafteter Long-Typ (immer 32 Bit, Byte-Folge maschinenabhngig)
          L ... vorzeichenloser Long-Typ (immer 32 Bit, Byte-Folge maschinenabhngig)
          V ... vorzeichenloser Long-Typ (immer 32 Bit, Little Endian)
 
 Parameter:  string $datensatz:  Datensatz als Zeichenkette
 
 return:  struct $eber:  Datensatz als Datenstruktur mit allen Datenfeldern 
                         (Eingabebereich)
*/
function aufbereitenDatensatz($datensatz)
{
/*
    $feldlaenge = array("ex"=>4,      // int (LittleEndian)
                        "ey"=>4,      // int (LittleEndian)
                        "ez"=>4);     // int (LittleEndian)
*/
    $eberstr = unpack("iex/iey/iez", $datensatz);

    $eber->ex = $eberstr["ex"];
    $eber->ey = $eberstr["ey"];
    $eber->ez = $eberstr["ez"];

    return $eber;
}
?>
