<?php 
// Include-Datei "artikel.inc.php"

/*
 *******************************************************************************
 Datei ALTBAND
 (bungen A39, A40, A41 und A42)
 -------------------------------------------------------------------------------
 @module  Fachbuch "Programmierlogik"
 @since   August 2008
 @version August 2009
 @author  Beringer Alfred
 *******************************************************************************
*/

const SATZLAENGEALTBAND = 55;

/*
 1 Datensatz wird in seine Einzelfelder zerlegt und - als Datenstruktur 
 aufbereitet - zurckgegeben.
 
 Parameter:  string $datensatz:  Datensatz als Zeichenkette
 
 return:  struct $eber:  Datensatz als Datenstruktur mit allen Datenfeldern 
                         (Eingabebereich)
*/
function aufbereitenDatensatzAltband($datensatz)
{
    $feldlaenge = array("bnr"   => 4,
                        "bbez"  =>20,
                        "bpreis"=> 7,      // float
                        "bbmeng"=> 5,      // int
                        "bsonst"=>19);

    $offset = 0;
    $eber->bnr    = substr($datensatz,$offset,$feldlaenge["bnr"]);
    $offset += $feldlaenge["bnr"];
    $eber->bbez   = substr($datensatz,$offset,$feldlaenge["bbez"]);
    $offset += $feldlaenge["bbez"];
    $eber->bpreis = substr($datensatz,$offset,$feldlaenge["bpreis"]);
    $offset += $feldlaenge["bpreis"];
    $eber->bbmeng = substr($datensatz,$offset,$feldlaenge["bbmeng"]);
    $offset += $feldlaenge["bbmeng"];
    $eber->bsonst = substr($datensatz,$offset,$feldlaenge["bsonst"]);

    $ok = settype($eber->bpreis, "double");
    $eber->bpreis = $eber->bpreis / 100;             // 2 Nachkommastellen
    $ok = settype($eber->bbmeng, "integer");

    return $eber;
}

/*
 1 Datensatz (als Datenstruktur) wird in eine Zeichenkette konvertiert, wobei 
 die Lngen der numerischen Datenfelder fix definiert werden.
 
 Parameter:  struct $eber:  Datensatz als Datenstruktur
 
 return:  string $str:  Datensatz als Zeichenkette
*/
function toStringAltband($eber)
{
    $eber->bpreis = $eber->bpreis * 100;             // 2 Nachkommastellen
    $str = sprintf("%s%s%07d%05d%s", $eber->bnr, 
                                     $eber->bbez, 
                                     $eber->bpreis, 
                                     $eber->bbmeng, 
                                     $eber->bsonst);
    return $str;
}
?>
