<?php 
// Include-Datei "kunden.inc.php"

/*
 *******************************************************************************
 Datei KUNDEN
 (bung A12)
 -------------------------------------------------------------------------------
 @module  Fachbuch "Programmierlogik"
 @since   August 2008
 @version August 2009
 @author  Beringer Alfred
 *******************************************************************************
*/

const SATZLAENGE = 34;

/*
 1 Datensatz wird in seine Einzelfelder zerlegt und - als Datenstruktur 
 aufbereitet - zurckgegeben.
 
 Parameter:  string $datensatz:  Datensatz als Zeichenkette
 
 return:  struct $eber:  Datensatz als Datenstruktur mit allen Datenfeldern 
                         (Eingabebereich)
*/
function aufbereitenDatensatz($datensatz)
{
    $feldlaenge = array("enr"   => 4,
                        "enam"  =>20,
                        "eschl" => 1,
                        "eums"  => 8,      // float
                        "esa"   => 1);

    $offset = 0;
    $eber->enr   = substr($datensatz,$offset,$feldlaenge["enr"]);
    $offset += $feldlaenge["enr"];
    $eber->enam  = substr($datensatz,$offset,$feldlaenge["enam"]);
    $offset += $feldlaenge["enam"];
    $eber->eschl = substr($datensatz,$offset,$feldlaenge["eschl"]);
    $offset += $feldlaenge["eschl"];
    $eber->eums  = substr($datensatz,$offset,$feldlaenge["eums"]);
    $offset += $feldlaenge["eums"];
    $eber->esa   = substr($datensatz,$offset,$feldlaenge["esa"]);

    $ok = settype($eber->eums, "double");
    $eber->eums = $eber->eums / 100;             // 2 Nachkommastellen

    return $eber;
}
?>
