<?php 
// Include-Datei "steuer.inc.php"

/*
 *******************************************************************************
 Datei STEUER
 (bung A28)
 -------------------------------------------------------------------------------
 @module  Fachbuch "Programmierlogik"
 @since   August 2008
 @version August 2009
 @author  Beringer Alfred
 *******************************************************************************
*/

const SATZLAENGE = 37;

/*
 1 Datensatz wird in seine Einzelfelder zerlegt und - als Datenstruktur 
 aufbereitet - zurckgegeben.
 
 Parameter:  string $datensatz:  Datensatz als Zeichenkette
 
 return:  struct $eber:  Datensatz als Datenstruktur mit allen Datenfeldern 
                         (Eingabebereich)
*/
function aufbereitenDatensatz($datensatz)
{
    $feldlaenge = array("ebl"   => 1,
                        "ebez"  => 2,
                        "egnam" =>20,
                        "egem"  => 4,
                        "esta"  =>10);     // float

    $offset = 0;
    $eber->ebl   = substr($datensatz,$offset,$feldlaenge["ebl"]);
    $offset += $feldlaenge["ebl"];
    $eber->ebez  = substr($datensatz,$offset,$feldlaenge["ebez"]);
    $offset += $feldlaenge["ebez"];
    $eber->egnam = substr($datensatz,$offset,$feldlaenge["egnam"]);
    $offset += $feldlaenge["egnam"];
    $eber->egem  = substr($datensatz,$offset,$feldlaenge["egem"]);
    $offset += $feldlaenge["egem"];
    $eber->esta  = substr($datensatz,$offset,$feldlaenge["esta"]);

    $ok = settype($eber->esta, "double");
    $eber->esta = $eber->esta / 100;             // 2 Nachkommastellen

    return $eber;
}
?>
