<?php 
// Include-Datei "strom.inc.php"

/*
 *******************************************************************************
 Datei STROM
 (bungen A33 und A35)
 -------------------------------------------------------------------------------
 @module  Fachbuch "Programmierlogik"
 @since   August 2008
 @version August 2009
 @author  Beringer Alfred
 *******************************************************************************
*/

const SATZLAENGE = 79;

/*
 1 Datensatz wird in seine Einzelfelder zerlegt und - als Datenstruktur 
 aufbereitet - zurckgegeben.
 
 Parameter:  string $datensatz:  Datensatz als Zeichenkette
 
 return:  struct $eber:  Datensatz als Datenstruktur mit allen Datenfeldern 
                         (Eingabebereich)
*/
function aufbereitenDatensatz($datensatz)
{
    $feldlaenge = array("eanr"  => 7,
                        "eznr"  => 7,
                        "ezsalt"=> 5,      // int
                        "ezsneu"=> 5,      // int
                        "esonst"=>54,
                        "eta"   => 1);

    $offset = 0;
    $eber->eanr   = substr($datensatz,$offset,$feldlaenge["eanr"]);
    $offset += $feldlaenge["eanr"];
    $eber->eznr   = substr($datensatz,$offset,$feldlaenge["eznr"]);
    $offset += $feldlaenge["eznr"];
    $eber->ezsalt = substr($datensatz,$offset,$feldlaenge["ezsalt"]);
    $offset += $feldlaenge["ezsalt"];
    $eber->ezsneu = substr($datensatz,$offset,$feldlaenge["ezsneu"]);
    $offset += $feldlaenge["ezsneu"];
    $eber->esonst = substr($datensatz,$offset,$feldlaenge["esonst"]);
    $offset += $feldlaenge["esonst"];
    $eber->eta    = substr($datensatz,$offset,$feldlaenge["eta"]);

    $ok = settype($eber->ezsalt, "integer");
    $ok = settype($eber->ezsneu, "integer");

    return $eber;
}
?>
