<?php 
// Include-Datei "theater.inc.php"

/*
 *******************************************************************************
 Datei THEATER
 (bung A38)
 -------------------------------------------------------------------------------
 @module  Fachbuch "Programmierlogik"
 @since   August 2008
 @version August 2009
 @author  Beringer Alfred
 *******************************************************************************
*/

const SATZLAENGE = 119;

/*
 1 Datensatz wird in seine Einzelfelder zerlegt und - als Datenstruktur 
 aufbereitet - zurckgegeben.
 
 Parameter:  string $datensatz:  Datensatz als Zeichenkette
 
 return:  struct $eber:  Datensatz als Datenstruktur mit allen Datenfeldern 
                         (Eingabebereich)
*/
function aufbereitenDatensatz($datensatz)
{
    $feldlaenge = array("ekennz"   => 1,
                        "estueck"  =>39,
                        "ename"    =>20,
                        "estamm"   =>15,
                        "ekat"     => 1,
                        "ezuschlag"=> 4,      // float
                        "erolle"   =>23,
                        "eprdat"   => 8,
                        "eldat"    => 8);

    $offset = 0;
    $eber->ekennz    = substr($datensatz,$offset,$feldlaenge["ekennz"]);
    $offset += $feldlaenge["ekennz"];
    $eber->estueck   = substr($datensatz,$offset,$feldlaenge["estueck"]);
    $offset += $feldlaenge["estueck"];
    $eber->ename     = substr($datensatz,$offset,$feldlaenge["ename"]);
    $offset += $feldlaenge["ename"];
    $eber->estamm    = substr($datensatz,$offset,$feldlaenge["estamm"]);
    $offset += $feldlaenge["estamm"];
    $eber->ekat      = substr($datensatz,$offset,$feldlaenge["ekat"]);
    $offset += $feldlaenge["ekat"];
    $eber->ezuschlag = substr($datensatz,$offset,$feldlaenge["ezuschlag"]);
    $offset += $feldlaenge["ezuschlag"];
    $eber->erolle    = substr($datensatz,$offset,$feldlaenge["erolle"]);
    $offset += $feldlaenge["erolle"];
    $eber->eprdat    = substr($datensatz,$offset,$feldlaenge["eprdat"]);
    $offset += $feldlaenge["eprdat"];
    $eber->eldat     = substr($datensatz,$offset,$feldlaenge["eldat"]);

    $ok = settype($eber->ezuschlag, "double");
    $eber->ezuschlag = $eber->ezuschlag / 100;   // 2 Nachkommastellen

    return $eber;
}
?>
