<?php 
// Include-Datei "vertret.inc.php"

/*
 *******************************************************************************
 Datei VERTRET
 (bungen A04, A05 und A15)
 -------------------------------------------------------------------------------
 @module  Fachbuch "Programmierlogik"
 @since   August 2008
 @version August 2009
 @author  Beringer Alfred
 *******************************************************************************
*/

const SATZLAENGE = 46;

/*
 1 Datensatz wird in seine Einzelfelder zerlegt und - als Datenstruktur 
 aufbereitet - zurckgegeben.
 
 Parameter:  string $datensatz:  Datensatz als Zeichenkette
 
 return:  struct $eber:  Datensatz als Datenstruktur mit allen Datenfeldern 
                         (Eingabebereich)
*/
function aufbereitenDatensatz($datensatz)
{
    $feldlaenge = array("enr"   => 6,
                        "enam"  =>29,
                        "eums"  =>11);     // float

    $offset = 0;
    $eber->enr  = substr($datensatz,$offset,$feldlaenge["enr"]);
    $offset += $feldlaenge["enr"];
    $eber->enam = substr($datensatz,$offset,$feldlaenge["enam"]);
    $offset += $feldlaenge["enam"];
    $eber->eums = substr($datensatz,$offset,$feldlaenge["eums"]);

    $ok = settype($eber->eums, "double");
    $eber->eums = $eber->eums / 100;             // 2 Nachkommastellen

    return $eber;
}
?>
