<?php 
// Include-Datei "vertretA3637.inc.php"

/*
 *******************************************************************************
 Datei VERTRET
 (bung A36 und A37)
 -------------------------------------------------------------------------------
 @module  Fachbuch "Programmierlogik"
 @since   August 2008
 @version August 2009
 @author  Beringer Alfred
 *******************************************************************************
*/

const SATZLAENGE = 12;

/*
 1 Datensatz wird in seine Einzelfelder zerlegt und - als Datenstruktur 
 aufbereitet - zurckgegeben.
 
 Parameter:  string $datensatz:  Datensatz als Zeichenkette
 
 return:  struct $eber:  Datensatz als Datenstruktur mit allen Datenfeldern 
                         (Eingabebereich)
*/
function aufbereitenDatensatz($datensatz)
{
    $feldlaenge = array("evnr"  => 2,      // short
                        "emonat"=> 2,      // short
                        "eums"  => 8);     // float

    $offset = 0;
    $eber->evnr   = substr($datensatz,$offset,$feldlaenge["evnr"]);
    $offset += $feldlaenge["evnr"];
    $eber->emonat = substr($datensatz,$offset,$feldlaenge["emonat"]);
    $offset += $feldlaenge["emonat"];
    $eber->eums   = substr($datensatz,$offset,$feldlaenge["eums"]);

    $ok = settype($eber->evnr,   "integer");
    $ok = settype($eber->emonat, "integer");
    $ok = settype($eber->eums,   "double");
    $eber->eums = $eber->eums / 100;             // 2 Nachkommastellen

    return $eber;
}
?>
