<!DOCTYPE html public "-//W3C//DTD XHTML 1.0 Transitional//EN"
                      "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<!-- Programm "a27C.php" -->
<html>
<head>
<meta name="author"      content="Beringer Alfred" />
<meta name="description" content="Programmierlogik" />
<meta name="keywords"    content="Programmieren, Buch, Programmierlogik, PHP, Programme" />

<title>A27 - Bin&auml;daten (C-Dateien)</title>
</head>
<body>

<pre>
<?php 
/*
 *******************************************************************************
 bung A27

 Kostenstellen/Kostenarten - zweifacher Gruppenwechsel.
 ---------------------------------------------------------------
 EINGABEDATEN: KOSTENDATEI
       AUFBAU:
         1 -  2 ( 2) ... KOSTENSTELLENNUMMER
         3 -  4 ( 2) ... KOSTENARTENNUMMER
         5 - 12 ( 8) ... BETRAG (2 NACHKOMMASTELLEN)
 
 DIE EINGABEDATEN SIND NACH KOSTENSTELLEN UND INNERHALB DIESER
 NACH KOSTENARTEN AUFSTEIGEND SORTIERT.
 SORTIERFEHLER SIND NICHT AUSZUSCHLIESSEN.
 ---------------------------------------------------------------
 AUSGABEDATEN: KOSTENBERSICHTSLISTE
       AUFBAU:
         1 SPALTENBERSCHRIFT
         1 LEERZEILE
 
         1 ZEILE PRO KOSTENART MIT
             KOSTENART
             SUMME KOSTENART
 
         1 ZEILE PRO KOSTENSTELLE MIT
             KOSTENSTELLE
             SUMME KOSTENSTELLE
             1 STERN
         DANACH 1 LEERZEILE
 
         1 GESAMTSUMMENZEILE MIT
             GESAMTSUMME
             2 STERNE
 
 PRO SEITE MAXIMAL 20 ZEILEN
      (EINSCHL. BERSCHRIFT + LEERZEILE,
       AUSGENOMMEN EV. SUMMENZEILEN).
 SUMMENZEILEN SOLLEN NIE UNMITTELBAR AUF DIE
 BERSCHRIFT FOLGEN.
 ---------------------------------------------------------------
 BEI SORTIERFEHLER NUR SPRECHENDE FEHLERMELDUNG.
 -------------------------------------------------------------------------------
 @module  Fachbuch "Programmierlogik"
 @since   August 2009
 @author  Beringer Alfred
 *******************************************************************************
*/

include_once "projektpfad.inc.php";

include_once PFAD . "ausgabesteuerungskonstante.inc.php";
include_once PFAD . "prozeduralCbinaer/Includedateien/kostenCbinaer.inc.php";

$EINGABEDATEI = PFAD . "DateienCbinaer/kosten.datC";

const HIGH = "\xff";
const LOW  = "\x00";

//const L0LEN = 1;
//const L1LEN = 3;
//const L2LEN = 5;

const ZMAX = 20;

const ABUE   = "<strong>KOSTENSTELLE  KOSTENART        SUMME  </strong><br />";
const F_ABL2 = "     %s          %s       % 10.2f  <br />";
const F_ABL1 = "     %s                 % 12.2f* <br />";
const F_ABL0 = "                      % 14.2f**<br />";
const ABF    = "SORTIERFOLGEFEHLER <br>";

// Datenstruktur $eb
// Datenstruktur $el,
//               $vl 
// Datenstruktur $abl2
// Datenstruktur $abl1
// Datenstruktur $abl0

// float $suml0
// float $suml1
// float $suml2
// int   $zz

/* -------------------------------------------------------------------------- */
$KOSTEN = fopen($EINGABEDATEI, "rb") 
             or die("<p>Die Datei <b>$EINGABEDATEI</b> existiert nicht.</p>");

uprogvor($el, $vl, $suml0, $zz);
uples($KOSTEN, $eb, $el);
while ($el->eof == $vl->eof)
{
    uphgvor($eb, $el, $vl, $abl1, $abl2, $suml1);
    while ($el->eof == $vl->eof && $el->gst1 == $vl->gst1)
    {
        upgrvor($eb, $el, $vl, $abl2, $suml2);
        while ($el->eof == $vl->eof && $el->gst1 == $vl->gst1 && $el->gst2 == $vl->gst2)
        {
            upeinzel($eb, $suml2);
            uples($KOSTEN, $eb, $el);
        }
        upgrnach($abl2, $suml2, $suml1, $zz, $el, $vl);
    }
    uphgnach($abl1, $suml1, $suml0, $zz);
}
uprognach($abl0, $suml0);

fclose($KOSTEN);
/* -------------------------------------------------------------------------- */

function uples(&$datei, &$eb, &$el)
{
    $datensatz = fread($datei, SATZLAENGE);
    if (feof($datei))
        $el->eof = HIGH;
    else
    {
        $eb = aufbereitenDatensatz($datensatz);
        $el->gst1 = $eb->ekst;
        $el->gst2 = $eb->eka;
    }
} // -------------------------------------------- Ende uples

function uprogvor(&$el, &$vl, &$suml0, &$zz)
{
    $el->eof = LOW;
    $zz = ZMAX;
    $suml0 = 0.0;
    $vl->eof = $el->eof;
} // -------------------------------------------- Ende uprogvor

function uphgvor($eb, $el, &$vl, &$abl1, &$abl2, &$suml1)
{
    $suml1 = 0.0;
    $abl1->akstl1 = $eb->ekst;
    $abl2->akstl2 = $eb->ekst;
    $vl->gst1 = $el->gst1;
} // -------------------------------------------- Ende uphgvor

function upgrvor($eb, $el, &$vl, &$abl2, &$suml2)
{
    $suml2 = 0.0;
    $abl2->akal2 = $eb->eka;
    $vl->gst2 = $el->gst2;
} // -------------------------------------------- Ende upgrvor

function upeinzel($eb, &$suml2)
{
    $suml2 = $suml2 + $eb->ebet;
} // -------------------------------------------- Ende upeinzel

function upgrnach(&$abl2, $suml2, &$suml1, &$zz, $el, $vl)
{
    $abl2->asuml2 = $suml2;
    upueb($zz, $abl2, $vl);
    printf(F_ABL2, $abl2->akstl2, $abl2->akal2, $abl2->asuml2);
    $zz++;
    $abl2->akstl2 = str_pad("", strlen($abl2->akstl2));
    $suml1 = $suml1 + $suml2;
    upsort($el, $vl, $abl2, $zz);
} // -------------------------------------------- Ende upgrnach

function uphgnach(&$abl1, $suml1, &$suml0, &$zz)
{
    $abl1->asuml1 = $suml1;
    printf(F_ABL1, $abl1->akstl1, $abl1->asuml1);
    printf(LEERZEILE);
    $zz = $zz + 2;
    $suml0 = $suml0 + $suml1;
} // -------------------------------------------- Ende uphgnach

function uprognach(&$abl0, $suml0)
{
    $abl0->asuml0 = $suml0;
    printf(F_ABL0, $abl0->asuml0);
} // -------------------------------------------- Ende uprognach

function upsort($el, $vl, &$abl2, &$zz)
{
    $elstr = $el->eof . $el->gst1 . $el->gst2;
    $vlstr = $vl->eof . $vl->gst1 . $vl->gst2;
    if ($elstr < $vlstr)
    {
        upueb($zz, $abl2, $vl);
        printf(ABF);
        $zz++;
    }
} // -------------------------------------------- Ende upsort

function upueb(&$zz, &$abl2, $vl)
{
    if ($zz >= ZMAX)
    {
        printf(NEUESEITE);
        printf(ABUE);
        printf(LEERZEILE);
        $zz = 2;
        $abl2->akstl2 = $vl->gst1;
    }
} // -------------------------------------------- Ende upueb

/* -------------------------------------------------------------------------- */
?>
</pre>

<p> </p><hr /><p> </p>

<address id="ende">
Copyright &#169; 2009<br />
Letzte Aktualisierung: 2010-02-01<br />
Beringer Alfred<br />
<a href="mailto:beringer@spengergasse.at">beringer@spengergasse.at</a>
</address>

</body>
</html>
