<!DOCTYPE html public "-//W3C//DTD XHTML 1.0 Transitional//EN"
                      "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<!-- Programm "a28zusC.php" -->
<html>
<head>
<meta name="author"      content="Beringer Alfred" />
<meta name="description" content="Programmierlogik" />
<meta name="keywords"    content="Programmieren, Buch, Programmierlogik, PHP, Programme" />

<title>A28zusatz - Bin&auml;daten (C-Dateien)</title>
</head>
<body>

<pre>
<?php 
/*
 *******************************************************************************
 bung A28

 Steueraufkommen - dreifacher Gruppenwechsel.
 ---------------------------------------------------------------
 EINGABEDATEN: STEUERDATEI
       AUFBAU:
           1    ( 1) ... BUNDESLANDSCHLSSEL ('1' - '9')
         2 -  3 ( 2) ... BEZIRKSCHLSSEL
         4 - 23 (20) ... GEMEINDENAME
        24 - 27 ( 4) ... GEMEINDEKENNZAHL (NICHT POSTLEITZAHL!)
        28 - 37 (10) ... STEUERAUFKOMMEN EINER PERSON (2 NACHKOMMAST.)
 
 DIE EINGABEDATEN SIND NACH BUNDESLNDERN, INNERHALB DIESER NACH
 BEZIRKEN UND INNERHALB DIESER NACH GEMEINDEN (GEMEINDEKENNZAHL)
 AUFSTEIGEND SORTIERT.
 DIE SORTIERFOLGE IST ZU PRFEN.
 ---------------------------------------------------------------
 AUSGABEDATEN: STEUERLISTE
       AUFBAU:
         1 SPALTENBERSCHRIFT
         1 LEERZEILE
 
         1 ZEILE PRO GEMEINDE MIT
             BUNDESLAND
             BEZIRK
             GEMEINDE
             SUMME STEUERAUFKOMMEN ALLER PERSONEN DIESER GEMEINDE
             
             BUNDESLAND UND BEZIRK NUR AM BEGINN DER GRUPPE UND
                                       AM BEGINN JEDER SEITE.
 
         1 ZEILE PRO BEZIRK MIT
             SUMME BEZIRK
             1 STERN
 
         1 ZEILE PRO BUNDESLAND MIT
             SUMME BUNDESLAND
             2 STERNE
 
         1 GESAMTSUMMENZEILE MIT
             GESAMTSUMME (STERREICHSUMME)
             3 STERNE
 
 PRO SEITE MAXIMAL 20 ZEILEN
      (EINSCHL. BERSCHRIFT + LEERZEILE,
       AUSGENOMMEN EV. SUMMENZEILEN).
 SUMMENZEILEN SOLLEN NIE UNMITTELBAR AUF DIE
 BERSCHRIFT FOLGEN.
 -------------------------------------------------------------------------------
 @module  Fachbuch "Programmierlogik"
 @since   August 2009
 @author  Beringer Alfred
 *******************************************************************************
*/

include_once "projektpfad.inc.php";

include_once PFAD . "ausgabesteuerungskonstante.inc.php";
include_once PFAD . "prozeduralCbinaer/Includedateien/steuerCbinaer.inc.php";

$EINGABEDATEI = PFAD . "DateienCbinaer/steuer.datC";

const HIGH = "\xff";
const LOW  = "\x00";

//const L0LEN = 1;
//const L1LEN = 2;
//const L2LEN = 4;
//const L3LEN = 8;

const ZMAX = 20;

const ABUE   = "<strong>BUNDESLAND  BEZIRK  GEMEINDE       STEUERAUFKOMMEN     </strong><br />";
const F_ABL3 = "    %s         %s      %s            % 12.2f    <br />";
const F_ABL2 = "                                  % 16.2f *  <br />";
const F_ABL1 = "                                % 18.2f ** <br />";
const F_ABL0 = "                               % 19.2f ***<br />";

// Datenstruktur $eb
// Datenstruktur $el,
//               $vl 
// Datenstruktur $abl3
// Datenstruktur $abl2
// Datenstruktur $abl1
// Datenstruktur $abl0

// float $suml0
// float $suml1
// float $suml2
// float $suml3
// int   $zz

/* -------------------------------------------------------------------------- */
$STEUER = fopen($EINGABEDATEI, "rb") 
             or die("<p>Die Datei <b>$EINGABEDATEI</b> existiert nicht.</p>");

uprogvor($el, $vl, $suml0, $zz);
uples($STEUER, $eb, $el);
while ($el->eof == $vl->eof)
{
    uphgvor($eb, $el, $vl, $abl3, $suml1);
    while ($el->eof == $vl->eof 
              && $el->gst1 == $vl->gst1)
    {
        upgrvor($eb, $el, $vl, $abl3, $suml2);
        while ($el->eof == $vl->eof 
                  && $el->gst1 == $vl->gst1 
                        && $el->gst2 == $vl->gst2)
        {
            upugvor($eb, $el, $vl, $abl3, $suml3);
            while ($el->eof == $vl->eof 
                      && $el->gst1 == $vl->gst1 
                            && $el->gst2 == $vl->gst2 
                                  && $el->gst3 == $vl->gst3)
            {
                upeinzel($eb, $suml3);
                uples($STEUER, $eb, $el);
            }
            upugnach($abl3, $suml3, $suml2, $zz, $vl);
        }
        upgrnach($abl2, $suml2, $suml1, $zz);
    }
    uphgnach($abl1, $suml1, $suml0, $zz);
}
uprognach($abl0, $suml0);

fclose($STEUER);
/* -------------------------------------------------------------------------- */

function uples(&$datei, &$eb, &$el)
{
    $datensatz = fread($datei, SATZLAENGE);
    if (feof($datei))
        $el->eof = HIGH;
    else
    {
        $eb = aufbereitenDatensatz($datensatz);
        $el->gst1 = $eb->ebl;
        $el->gst2 = $eb->ebez;
        $el->gst3 = $eb->egem;
    }
} // -------------------------------------------- Ende uples

function uprogvor(&$el, &$vl, &$suml0, &$zz)
{
    $el->eof = LOW;
    $zz = ZMAX;
    $suml0 = 0.0;
    $vl->eof = $el->eof;
} // -------------------------------------------- Ende uprogvor

function uphgvor($eb, $el, &$vl, &$abl3, &$suml1)
{
    $suml1 = 0.0;
    $abl3->abll3 = $eb->ebl;
    $vl->gst1 = $el->gst1;
} // -------------------------------------------- Ende uphgvor

function upgrvor($eb, $el, &$vl, &$abl3, &$suml2)
{
    $suml2 = 0.0;
    $abl3->abezl3 = $eb->ebez;
    $vl->gst2 = $el->gst2;
} // -------------------------------------------- Ende upgrvor

function upugvor($eb, $el, &$vl, &$abl3, &$suml3)
{
    $suml3 = 0.0;
    $abl3->ageml3 = $eb->egem;
    $vl->gst3 = $el->gst3;
} // -------------------------------------------- Ende upugvor

function upeinzel($eb, &$suml3)
{
    $suml3 = $suml3 + $eb->esta;
} // -------------------------------------------- Ende upeinzel

function upugnach(&$abl3, $suml3, &$suml2, &$zz, $vl)
{
    $abl3->asuml3 = $suml3;
    upueb($zz, $abl3, $vl);
    printf(F_ABL3, $abl3->abll3, $abl3->abezl3, $abl3->ageml3, $abl3->asuml3);
    $zz++;
    $abl3->abll3  = str_pad("", strlen($abl3->abll3));
    $abl3->abezl3 = str_pad("", strlen($abl3->abezl3));
    $abl3->ageml3 = str_pad("", strlen($abl3->ageml3));
    $suml2 = $suml2 + $suml3;
} // -------------------------------------------- Ende upugnach

function upgrnach(&$abl2, $suml2, &$suml1, &$zz)
{
    $abl2->asuml2 = $suml2;
    printf(F_ABL2, $abl2->asuml2);
    printf(LEERZEILE);
    $zz = $zz + 2;
    $suml1 = $suml1 + $suml2;
} // -------------------------------------------- Ende upgrnach

function uphgnach(&$abl1, $suml1, &$suml0, &$zz)
{
    $abl1->asuml1 = $suml1;
    printf(F_ABL1, $abl1->asuml1);
    printf(LEERZEILE);
    $zz = $zz + 2;
    $suml0 = $suml0 + $suml1;
} // -------------------------------------------- Ende uphgnach

function uprognach(&$abl0, $suml0)
{
    $abl0->asuml0 = $suml0;
    printf(F_ABL0, $abl0->asuml0);
} // -------------------------------------------- Ende uprognach

function upueb(&$zz, &$abl3, $vl)
{
    if ($zz >= ZMAX)
    {
        printf(NEUESEITE);
        printf(ABUE);
        printf(LEERZEILE);
        $zz = 2;
        $abl3->abll3 = $vl->gst1;
        $abl3->abezl3 = $vl->gst2;
    }
} // -------------------------------------------- Ende upueb

/* -------------------------------------------------------------------------- */
?>
</pre>

<p> </p><hr /><p> </p>

<address id="ende">
Copyright &#169; 2009<br />
Letzte Aktualisierung: 2010-02-01<br />
Beringer Alfred<br />
<a href="mailto:beringer@spengergasse.at">beringer@spengergasse.at</a>
</address>

</body>
</html>
