<!DOCTYPE html public "-//W3C//DTD XHTML 1.0 Transitional//EN"
                      "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<!-- Programm "a33C.php" -->
<html>
<head>
<meta name="author"      content="Beringer Alfred" />
<meta name="description" content="Programmierlogik" />
<meta name="keywords"    content="Programmieren, Buch, Programmierlogik, PHP, Programme" />

<title>A33 - Bin&auml;daten (C-Dateien)</title>
</head>
<body>

<pre>
<?php 
/*
 *******************************************************************************
 bung A33

 Stromabrechnung - eindimensionale Tabelle - sequentieller Zugriff
                   (2 Tabellen: Argument- und Wertetabelle).
 Basierend auf bung A31.
 ---------------------------------------------------------------
 EINGABEDATEN: STROMDATEI
       AUFBAU:
         1 -  7 ( 4) ... ABNEHMERNUMMER
         8 - 14 ( 7) ... ZHLERNUMMER
        15 - 19 ( 5) ... ZHLERSTAND ALT
        20 - 24 ( 5) ... ZHLERSTAND NEU
        25 - 78 (54) ... ANDERE DATEN
           79   ( 1) ... TARIF
 ---------------------------------------------------------------
 AUSGABEDATEN: ABRECHNUNGSLISTE
       AUFBAU:
         2 SPALTENBERSCHRIFTEN
         1 LEERZEILE
 
         1 ZEILE FR JEDEN DATENSATZ MIT
             ABNEHMERNUMMER
             ZHLERNUMMER
             ZHLERSTAND ALT
             ZHLERSTAND NEU
             VERBRAUCH (IN KWH)
             TARIF
             PREIS (JE NACH TARIF)
             ZAHLUNGSBETRAG
 
 PRO SEITE MAXIMAL 22 ZEILEN
      (EINSCHL. BERSCHRIFTEN + LEERZEILE).
 BERSCHRIFT NIE ALLEIN AUF EINER SEITE.
 ---------------------------------------------------------------
 DER PREIS WIRD AUS ZWEI TABELLEN (TARIF - PREIS) ERMITTELT.
 -------------------------------------------------------------------------------
 @module  Fachbuch "Programmierlogik"
 @since   August 2009
 @author  Beringer Alfred
 *******************************************************************************
*/

include_once "projektpfad.inc.php";

include_once PFAD . "ausgabesteuerungskonstante.inc.php";
include_once PFAD . "prozeduralCbinaer/Includedateien/stromCbinaer.inc.php";

$EINGABEDATEI = PFAD . "DateienCbinaer/strom.datC";

const ZZG = 22;

const UEB1       = "<strong>ABNEHMER-  Z&Auml;HLER-  Z&Auml;HLERSTAND  VERBRAUCH  TARIF  PREIS  ZAHLUNGS-</strong><br />";
const UEB2       = "<strong>  NUMMER   NUMMER    ALT   NEU     (KWH)          PRO KWH   BETRAG </strong><br />";
const F_ABER1    = " %s   %s  %5d %5d    %5d      %s   ";
const F_ABER2_OK = "% 5.2f % 10.2f <br />";
const F_ABER2_F  = "%s <br />";

const FTEXT = "FALSCHER TARIF";

// Datenstruktur $eber
// Datenstruktur $aber
// Datenstruktur $aberf
// Datenstruktur $ab

// int   $verbr
// float $preis
// float $zbet

$zz = 99;

/* -------------------------------------------------------------------------- */
$STROM = fopen($EINGABEDATEI, "rb") 
            or die("<p>Die Datei <b>$EINGABEDATEI</b> existiert nicht.</p>");

$datensatz = fread($STROM, SATZLAENGE);
while (!feof($STROM))
{
    $eber = aufbereitenDatensatz($datensatz);
    $aber = upaber($eber, $verbr);
    if ($zz >= ZZG)
        upueber($zz);
    printf(F_ABER1, $aber->aanr,
                    $aber->aznr,
                    $aber->azsalt,
                    $aber->azsneu,
                    $aber->averbr,
                    $aber->ata);
    $preis = upsuch($eber);
    if ($preis == 0.0)
    {
        printf(F_ABER2_F, FTEXT);
    }
    else
    {
        $aber->apreis = $preis;
        $zbet = $verbr * $preis;
        $aber->azbet = $zbet;
        printf(F_ABER2_OK, $aber->apreis,
                           $aber->azbet);
    }
    $zz++;
    $datensatz = fread($STROM, SATZLAENGE);
}

fclose($STROM);
/* -------------------------------------------------------------------------- */

function upaber($eber, &$verbr)
{
// Datenstruktur $ab

    $ab->aanr = $eber->eanr;
    $ab->aznr = $eber->eznr;
    $ab->azsalt = $eber->ezsalt;
    $ab->azsneu = $eber->ezsneu;
    $verbr = $eber->ezsneu - $eber->ezsalt;
    $ab->averbr = $verbr;
    $ab->ata = $eber->eta;
    $ab->apreis = -1.0;
    $ab->azbet  = -1.0;
    
    return $ab;
} // -------------------------------------------- Ende upaber

function upueber(&$zz)
{
    printf(NEUESEITE);
    printf(UEB1);
    printf(UEB2);
    printf(LEERZEILE);
    $zz = 3;
} // -------------------------------------------- Ende upueber

function upsuch($eber)
{
    $taba = array( 1=> '2',  '4',  '5',  '8',  '9' );
    $tabf = array( 1=>4.80, 5.01, 5.37, 5.41, 5.74 );
// short $n

    $preis = 0.0;

    $n = 1;
    while ($n <= count($taba))
    {
        if ($eber->eta == $taba[$n])
        {
            $preis = $tabf[$n];
            $n = count($taba);
        }
        $n++;
    }
    return $preis;
} // -------------------------------------------- Ende upsuch

/* -------------------------------------------------------------------------- */
?>
</pre>

<p> </p><hr /><p> </p>

<address id="ende">
Copyright &#169; 2009<br />
Letzte Aktualisierung: 2010-02-01<br />
Beringer Alfred<br />
<a href="mailto:beringer@spengergasse.at">beringer@spengergasse.at</a>
</address>

</body>
</html>
