<!DOCTYPE html public "-//W3C//DTD XHTML 1.0 Transitional//EN"
                      "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<!-- Programm "a37C.php" -->
<html>
<head>
<meta name="author"      content="Beringer Alfred" />
<meta name="description" content="Programmierlogik" />
<meta name="keywords"    content="Programmieren, Buch, Programmierlogik, PHP, Programme" />

<title>A37 - Bin&auml;daten (C-Dateien)</title>
</head>
<body>

<pre>
<?php 
/*
 *******************************************************************************
 bung A37

 Umsatzstatistik - zweidimensionale Tabelle (Monat, Vertreter).
 ---------------------------------------------------------------
 EINGABEDATEN: VERTRETERUMSATZDATEI
       AUFBAU:
         1 -  2 ( 2) ... VERTRETERNUMMER (01 - 15)
         3 -  4 ( 2) ... MONAT (01 - 12)
         5 - 12 ( 8) ... VERTRETERUMSATZ (2 NACHKOMMASTELLEN)
 
 DIE REIHENFOLGE DER DATEN IST UNBESTIMMT.
 ---------------------------------------------------------------
 AUSGABEDATEN: JAHRESUMSATZSTATISTIKLISTE
       AUFBAU:
         1 HAUPTBERSCHRIFT
         1 LEERZEILE
         1 SPALTENBERSCHRIFT
         1 LEERZEILE
 
         1 ZEILE PRO VERTRETER MIT
             VERTRETERNUMMER
             12 MONATSUMSTZE DES VERTRETERS
             JAHRESUMSATZ DES VERTRETERS
 
         1 LEERZEILE UND
         1 GESAMTSUMMENZEILE MIT
             12 MONATSGESAMTUMSTZE
             JAHRESGESAMTUMSATZ
 -------------------------------------------------------------------------------
 @module  Fachbuch "Programmierlogik"
 @since   August 2009
 @author  Beringer Alfred
 *******************************************************************************
*/

include_once "projektpfad.inc.php";

include_once PFAD . "ausgabesteuerungskonstante.inc.php";
include_once PFAD . "prozeduralCbinaer/Includedateien/vertretA3637Cbinaer.inc.php";

$EINGABEDATEI = PFAD . "DateienCbinaer/vertreterA3637.datC";

const ZMAX = 10;

const ABUE1   = "<strong>                                                       JAHRESUMSATZSTATISTIK </strong><br />";
const ABUE2   = "<strong>         01        02        03        04        05        06        07        08        09        10        11        12          SUMME</strong><br />";
const F_AB    = "            %02d           % 10.2f<br />";
const F_ABL   = "          SUMME        % 12.2f<br />";
const F_ABFEL = "FALSCHER MONAT ODER VERTRETER:   %6d  %6d  % 10.2f<br />";

// Datenstruktur $eb
// Datenstruktur $ab
// Datenstruktur $abl

const ANZMONAT = 12;
const ANZVNR   = 15;

// t2sum [ANZVNR][ANZMONAT];
$t1sum = array( 1=>0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 );

/*
static struct AB
{
  short int avnr;
  float     asum[ANZMONAT],
            azsum;
} ab;

static struct ABL
{
  float agsum[ANZMONAT],
        agzsum;
} abl;

*/

/* -------------------------------------------------------------------------- */
$VERTRET = fopen($EINGABEDATEI, "rb") 
              or die("<p>Die Datei <b>$EINGABEDATEI</b> existiert nicht.</p>");

uprogvor($t2sum);
$datensatz = fread($VERTRET, SATZLAENGE);
while (!feof($VERTRET))
{
    $eb = aufbereitenDatensatz($datensatz);
    upva($eb, $t2sum);
    $datensatz = fread($VERTRET, SATZLAENGE);
}
uprognach($t2sum);

fclose($VERTRET);
/* -------------------------------------------------------------------------- */

function uprogvor(&$t2sum)
{
// short $rvnr
// short $rmonat

    $rvnr = 1;
    while ($rvnr <= ANZVNR)
    {
      $rmonat = 1;
      while ($rmonat <= ANZMONAT)
      {
          $t2sum[$rvnr][$rmonat] = 0.0;
          $rmonat++;
      }
      $rvnr++;
    }
} // -------------------------------------------- Ende uprogvor

function upva($eb, &$t2sum)
{
    $rvnr   = $eb->evnr;
    $rmonat = $eb->emonat;

    if ($rvnr < 1)
    {
        upf($eb);
        return;
    }
    if ($rvnr > ANZVNR)
    {
        upf($eb);
        return;
    }

    if ($rmonat < 1)
    {
        upf($eb);
        return;
    }
    if ($rmonat > ANZMONAT)
    {
        upf($eb);
        return;
    }

    $t2sum[$rvnr][$rmonat] += $eb->eums;
} // -------------------------------------------- Ende upva

function uprognach($t2sum)
{
// float $gsum
// short $rvnr
// short rmonat
    $zz = 99;

    upueb($zz);
    upvnrvor($t1sum);
    $rvnr = 1;
    while ($rvnr <= ANZVNR)
    {
        upmonatvor($rvnr, $gsum, $ab);
        $rmonat = 1;
        while ($rmonat <= ANZMONAT)
        {
            uptabeinzel($rvnr, $rmonat, $t2sum, $t1sum, $ab, $gsum);
            $rmonat++;
        }
        upmonatnach($gsum, $ab);
        $zz = $zz + 1;
        if ($zz >= ZMAX)
            upueb($zz);
        $rvnr++;
    }
    upvnrnach($t1sum);
} // -------------------------------------------- Ende uprognach

function upvnrvor(&$t1sum)
{
    $rmonat = 1;
    while ($rmonat <= ANZMONAT)
    {
        $t1sum[$rmonat] = 0.0;
        $rmonat++;
    }
} // -------------------------------------------- Ende upvnrvor

function upmonatvor($rvnr, &$gsum, &$ab)
{
    $ab->avnr = $rvnr;
    printf("%02d ", $ab->avnr);
    $gsum = 0.0;
} // -------------------------------------------- Ende upmonatvor

function uptabeinzel($rvnr, $rmonat, $t2sum, &$t1sum, &$ab, &$gsum)
{
    $ab->asum[$rmonat] = $t2sum[$rvnr][$rmonat];
    printf("% 9.1f ", $ab->asum[$rmonat]);
    $gsum = $gsum + $t2sum[$rvnr][$rmonat];
    $t1sum[$rmonat] = $t1sum[$rmonat] + $t2sum[$rvnr][$rmonat];
} // -------------------------------------------- Ende uptabeinzel

function upmonatnach($gsum, &$ab)
{
  $ab->azsum = $gsum;
  printf("  %12.1f<br />", $ab->azsum);
} // -------------------------------------------- Ende upmonatnach

function upvnrnach($t1sum)
{
    $gsum = 0.0;
    $rmonat = 1;

    printf("<br />SU ");
    while ($rmonat <= ANZMONAT)
    {
        $abl->agsum[$rmonat] = $t1sum[$rmonat];
        printf("%9.1f ", $abl->agsum[$rmonat]);
        $gsum = $gsum + $t1sum[$rmonat];
        $rmonat++;
    }
    $abl->agzsum = $gsum;
    printf("  %12.1f<br />", $abl->agzsum);
} /* ----- Ende upvnrnach */

function upueb(&$zz)
{
    printf(NEUESEITE);
    printf(ABUE1);
    printf(LEERZEILE);
    printf(ABUE2);
    printf(LEERZEILE);
    $zz = 4;
} // -------------------------------------------- Ende upueb

function upf($eb)
{
  printf(F_ABFEL, $eb->evnr, $eb->emonat, $eb->eums);
} // -------------------------------------------- Ende upf

/* -------------------------------------------------------------------------- */
?>
</pre>

<p> </p><hr /><p> </p>

<address id="ende">
Copyright &#169; 2009<br />
Letzte Aktualisierung: 2010-02-01<br />
Beringer Alfred<br />
<a href="mailto:beringer@spengergasse.at">beringer@spengergasse.at</a>
</address>

</body>
</html>
