<!DOCTYPE html public "-//W3C//DTD XHTML 1.0 Transitional//EN"
                      "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<!-- Programm "a40C.php" -->
<html>
<head>
<meta name="author"      content="Beringer Alfred" />
<meta name="description" content="Programmierlogik" />
<meta name="keywords"    content="Programmieren, Buch, Programmierlogik, PHP, Programme" />

<title>A40 - Bin&auml;daten (C-Dateien)</title>
</head>
<body>

<pre>
<?php 
/*
 *******************************************************************************
 bung A40 (Version 2)

 Mischlogik - Artikelstze lschen,
              zustzliche Ausgabe der aktuellen Artikelliste.
 ---------------------------------------------------------------
 EINGABEDATEN: ARTIKELDATEI
       AUFBAU:
         1 -  4 ( 4) ... ARTIKELNUMMER
         5 - 24 (20) ... ARTIKELBEZEICHNUNG
        25 - 31 ( 7) ... EINZELPREIS
        32 - 36 ( 5) ... BESTANDSMENGE
        37 - 55 (19) ... SONSTIGE DATEN
 
 EINGABEDATEN: LSCHDATEI
       AUFBAU:
         1 -  4 ( 4) ... ARTIKELNUMMER
 
 BEIDE DATEIEN SIND AUFSTEIGEND SORTIERT NACH DER
 ARTIKELNUMMER.
 PRO ARTIKELNUMMER GIBT ES NUR 1 EINGABEDATENSATZ.
 ---------------------------------------------------------------
 AUSGABEDATEN: AKTUALISIERTE ARTIKELDATEI
 
               AKTUALISIERTE ARTIKELLISTE
 
               FEHLERPROTOKOLL
                      ZU LSCHENDE ARTIKELNUMMER NICHT VORHANDEN
                      SORTIERFOLGEFEHLER IN DER LSCHDATEI
 -------------------------------------------------------------------------------
 @module  Fachbuch "Programmierlogik"
 @since   August 2009
 @author  Beringer Alfred
 *******************************************************************************
*/

include_once "projektpfad.inc.php";

include_once PFAD . "ausgabesteuerungskonstante.inc.php";
include_once PFAD . "prozeduralCbinaer/Includedateien/artikelCbinaer.inc.php";
include_once PFAD . "prozeduralCbinaer/Includedateien/kloeschCbinaer.inc.php";

$DATEIALT = PFAD . "DateienCbinaer/artikel.datC";
$DATEINEU = PFAD . "DateienCbinaer/NEUBAND.datC";
$DATEI    = PFAD . "DateienCbinaer/kloesch.datC";

const HIGH = "\xff";
const LOW  = "\x00";

const ZZG  = 22;
const ZZGF = 22;

const ABUEB  = "<strong>ARTIKELLISTE</strong><br />";
const F_ABER = "%s %s  %7.2f   %s<br />";
const TEXT   = "GELOESCHT";

const FUEB   = "<strong>FEHLERPROTOKOLL</strong><br />";
const F_FBER = "%s %s<br />";
const FEHL1  = "ARTIKEL NICHT VORHANDEN       ";
const FEHL2  = "SORTIERFOLGEFEHLER            ";

// Datenstruktur $bber
// Datenstruktur $kber
// Datenstruktur $fber

// Datenstrukturen $bl1, $kl1, $vl1

// Datenstruktur $aber

// int $dz

$zz  = 99;
$zzf = 99;

/* -------------------------------------------------------------------------- */
$ALTBAND = fopen($DATEIALT, "rb") 
              or die("<p>Die Datei <b>$DATEIALT</b> existiert nicht.</p>");
$NEUBAND = fopen($DATEINEU,"wb")
              or die("<p>Sie k&ouml;nnen die Datei <b>$DATEINEU</b> leider nicht erstellen.</p>");
$KLOESCH = fopen($DATEI, "rb") 
              or die("<p>Die Datei <b>$DATEI</b> existiert nicht.</p>");

uprogvor($dz, $bl1, $kl1, $vl1);
uplesaltband($ALTBAND, $dz, $bber, $bl1);
upleskloesch($KLOESCH, $dz, $kber, $kl1);
while ($dz > 0)
{
    $kstr = $kl1->eof . $kl1->sort1;
    $vstr = $vl1->eof . $vl1->sort1;
    if ($kstr <= $vstr)
    {
        $fber->fmeld = FEHL2;
        upschrf($zzf, $fber, $kber);
        upleskloesch($KLOESCH, $dz, $kber, $kl1);
    }
    else
        upmisch($ALTBAND, $bber, $bl1, $KLOESCH, $kber, $kl1, $NEUBAND, 
                $vl1, $dz, $zz, $fber, $zzf);
}

fclose($ALTBAND);
fclose($NEUBAND);
fclose($KLOESCH);
/* -------------------------------------------------------------------------- */

function uplesaltband(&$datei, &$dz, &$bber, &$bl1)
{
    $datensatz = fread($datei, SATZLAENGEALTBAND);
    if (feof($datei))
    {
        $bl1->eof = HIGH;
        $dz--;
    }
    else
    {
        $bber = aufbereitenDatensatzAltband($datensatz);
        $bl1->sort1 = $bber->bnr;
    }
} // -------------------------------------------- Ende uplesaltband

function upleskloesch(&$datei, &$dz, &$kber, &$kl1)
{
    $datensatz = fread($datei, SATZLAENGEKLOESCH);
    if (feof($datei))
    {
        $kl1->eof = HIGH;
        $dz--;
    }
    else
    {
        $kber = aufbereitenDatensatzAltband($datensatz);
        $kl1->sort1 = $kber->knr;
    }
} // -------------------------------------------- Ende upleskloesch

function uprogvor(&$dz, &$bl1, &$kl1, &$vl1)
{
    $bl1->eof = LOW;
    $kl1->eof = LOW;
    $vl1->eof = LOW;
    $vl1->sort1 = str_pad(LOW, strlen($vl1->sort1));
    $dz = 2;
} // -------------------------------------------- Ende uprogvor

function upmisch(&$ALTBAND, &$bber, &$bl1, 
                 &$KLOESCH, &$kber, &$kl1, 
                 &$NEUBAND, &$vl1, &$dz, &$zz, &$fber, &$zzf)
{
    $bstr = $bl1->eof . $bl1->sort1;
    $kstr = $kl1->eof . $kl1->sort1;
    if ($bl1 < $kl1)
    {
        upschr($zz, $aber, $bber);
        $str = toStringAltband($bber);
        fwrite($NEUBAND, $str, SATZLAENGEALTBAND);
        uplesaltband($ALTBAND, $dz, $bber, $bl1);
    }
    else
    {
        $bstr = $bl1->eof . $bl1->sort1;
        $kstr = $kl1->eof . $kl1->sort1;
        if ($bstr == $kstr)
        {
            $aber->atext = TEXT;
            upschr($zz, $aber, $bber);
            uplesaltband($ALTBAND, $dz, $bber, $bl1);
            $vl1->sort1 = $kl1->sort1;
            upleskloesch($KLOESCH, $dz, $kber, $kl1);
        }
        else
        {
            $fber->fmeld = FEHL1;
            upschrf($zzf, $fber, $kber);
            $vl1->sort1 = $kl1->sort1;
            upleskloesch($KLOESCH, $dz, $kber, $kl1);
        }
    }
} // -------------------------------------------- Ende upmisch

function upschr(&$zz, &$aber, $bber)
{
    $aber->anr = $bber->bnr;
    $aber->abez = $bber->bbez;
    $aber->apreis = $bber->bpreis;
    if ($zz >= ZZG)
        upueb($zz);
    printf(F_ABER, $aber->anr, $aber->abez, $aber->apreis, $aber->atext);
    $zz++;
    $aber->atext = " ";
} // -------------------------------------------- Ende upschr

function upueb(&$zz)
{
    printf(NEUESEITE);
    printf(ABUEB);
    printf(LEERZEILE);
    $zz = 2;
} // -------------------------------------------- Ende upueb

function upschrf(&$zzf, &$fber, $kber)
{
    $fber->fnr = $kber->knr;
    if ($zzf >= ZZGF)
        upuebf($zzf);
    printf(F_FBER, $fber->fnr, $fber->fmeld);
    $zzf++;
} // -------------------------------------------- Ende upschrf

function upuebf(&$zzf)
{
    printf(NEUESEITE);
    printf(FUEB);
    printf(LEERZEILE);
    $zzf = 2;
} // -------------------------------------------- Ende upuebf

/* -------------------------------------------------------------------------- */
?>
</pre>

<p> </p><hr /><p> </p>

<address id="ende">
Copyright &#169; 2009<br />
Letzte Aktualisierung: 2010-02-01<br />
Beringer Alfred<br />
<a href="mailto:beringer@spengergasse.at">beringer@spengergasse.at</a>
</address>

</body>
</html>
