<!DOCTYPE html public "-//W3C//DTD XHTML 1.0 Transitional//EN"
                      "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<!-- Programm "a03includepfad.php" -->
<html>
<head>
<meta name="author"      content="Beringer Alfred" />
<meta name="description" content="Programmierlogik" />
<meta name="keywords"    content="Programmieren, Buch, Programmierlogik, PHP, Programme" />

<title>A03 mit 'include' des Projektpfads</title>
</head>
<body>

<pre>
<?php 
/*
 *******************************************************************************
 bung A03

 Schlerliste - aufbereiten Datenfelder, Seitenvorschub.
 Verwendung von 'include'
 ---------------------------------------------------------------
 EINGABEDATEN: SCHLERDATEI
       AUFBAU:
         1 - 20 (20) ... FAMILIENNAME
        21 - 30 (10) ... VORNAME
           31   ( 1) ... GESCHLECHT
        32 - 39 ( 8) ... GEBURTSDATUM (IN DER FORM JJJJMMTT)
        40 - 41 ( 2) ... RELIGION (VERSCHLSSELT)
        42 - 44 ( 3) ... STAATSBRGERSCHAFT
        45 - 49 ( 5) ... KLASSE
        50 - 53 ( 4) ... POSTLEITZAHL
        54 - 65 (12) ... ORT
        66 - 80 (15) ... STRASSE
 ---------------------------------------------------------------
 AUSGABEDATEN: SCHLERLISTE
       AUFBAU:
         1 ZEILE PRO SCHLER MIT
             FAMILIENNAME
             VORNAME
             GEBURTSDATUM

 PRO SEITE MAXIMAL 22 ZEILEN.
 -------------------------------------------------------------------------------
 @module  Fachbuch "Programmierlogik"
 @since   August 2008
 @version August 2009
 @author  Beringer Alfred
 *******************************************************************************
*/

/*
 Die Konstante fr den relativen Pfad zum privaten Projektverzeichnis befindet 
 sich im aktuellen (ffentlichen) Verzeichnis in einer Include-Datei und wird 
 durch den nachfolgenden 'include'-Befehl in das Programm eingefgt:
*/
include_once "projektpfad.inc.php";

/*
 Die Ausgabekonstante 'NEUESEITE' befindet sich in einer Include-Datei und 
 wird durch den nachfolgenden 'include'-Befehl in das Programm eingefgt:
*/
include_once PFAD . "ausgabesteuerungskonstante.inc.php";

/*
 Die Aufbereitung der Struktur fr den Eingabebereich befindet sich in einer
 Include-Datei und wird durch den nachfolgenden 'include'-Befehl in das
 Programm eingefgt:
*/
include_once PFAD . "prozeduraleSkripte/Includedateien/schueler.inc.php";

/*
 Die tatschlich verwendete Datei wird im 'fopen'-Befehl festgelegt.
 Um den Dateinamen und/oder den Pfad ndern zu knnnen (z.B. durch eine 
 Benutzereingabe), wird die folgende Variable 'EINGABEDATEI' definiert (der 
 Einfachheit halber wird der Dateiname mit dem Pfad jedoch fix vorgegeben):
*/
$EINGABEDATEI = PFAD . "DateienASCII/vormerk.dat";
//$EINGABEDATEI = PFAD . "DateienASCII/schueler.dat";

/*
 Die maximale Anzahl der Zeilen pro Seite (die Zeilenzhlergrenze) wird als 
 Konstante definiert:
*/
const ZZG = 22;

/*
 Das Ausgabeformat einer Zeile wird als Konstante definiert:
*/
const F_AB = "      %s     %s       %s<br />";

// Datenstruktur $eb
// Datenstruktur $ab

// int $zz

/* -------------------------------------------------------------------------- */
$VORMERK = fopen($EINGABEDATEI, "rb") 
              or die("<p>Die Datei <b>$EINGABEDATEI</b> existiert nicht.</p>");
  
$zz = 0;
$datensatz = fread($VORMERK, SATZLAENGE);
while (!feof($VORMERK))
{
    $eb = aufbereitenDatensatz($datensatz);
    $ab->afn = $eb->efn;
    $ab->avn = $eb->evn;
    $ab->agd = $eb->egd;
    if ($zz >= ZZG)
    {
        printf(NEUESEITE);
        $zz = 0;
    }
    printf(F_AB, $ab->afn, $ab->avn, $ab->agd);
    $zz = $zz + 1;
    $datensatz = fread($VORMERK, SATZLAENGE);
}

fclose($VORMERK);

/* -------------------------------------------------------------------------- */
?>
</pre>

<p> </p><hr /><p> </p>

<address id="ende">
Copyright &#169; 2008<br />
Letzte Aktualisierung: 2010-02-01<br />
Beringer Alfred<br />
<a href="mailto:beringer@spengergasse.at">beringer@spengergasse.at</a>
</address>

</body>
</html>
