<!DOCTYPE html public "-//W3C//DTD XHTML 1.0 Transitional//EN"
                      "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<!-- Programm "a04.php" -->
<html>
<head>
<meta name="author"      content="Beringer Alfred" />
<meta name="description" content="Programmierlogik" />
<meta name="keywords"    content="Programmieren, Buch, Programmierlogik, PHP, Programme" />

<title>A04</title>
</head>
<body>

<pre>
<?php 
/*
 *******************************************************************************
 bung A04

 Vertreterliste - berschrift, Rechenfelder, Datentypen, lfd. Nr., Satzzhler.
 ---------------------------------------------------------------
 EINGABEDATEN: VERTRETERUMSATZDATEI
       AUFBAU:
         1 -  6 ( 6) ... VERTRETERNUMMER
         7 - 35 (29) ... VERTRETERNAME
        36 - 46 (11) ... VERTRETERUMSATZ (2 NACHKOMMASTELLEN)
 ---------------------------------------------------------------
 AUSGABEDATEN: VERTRETERUMSATZLISTE
       AUFBAU:
         1 SPALTENBERSCHRIFT UND
         1 LEERZEILE
 
         1 ZEILE PRO VERTRETER MIT
             LAUFENDER NUMMER
             VERTRETERNAME
             VERTRETERUMSATZ
             VERTRETERNUMMER
 
 PRO SEITE MAXIMAL 22 ZEILEN (EINSCHL. BERSCHRIFT + LEERZEILE).
 DIE BERSCHRIFT SOLL NIE ALLEIN AUF EINER SEITE STEHEN.
 -------------------------------------------------------------------------------
 @module  Fachbuch "Programmierlogik"
 @since   August 2008
 @version August 2009
 @author  Beringer Alfred
 *******************************************************************************
*/

/*
 Die Konstante fr den relativen Pfad zum privaten Projektverzeichnis befindet 
 sich im aktuellen (ffentlichen) Verzeichnis in einer Include-Datei und wird 
 durch den nachfolgenden 'include'-Befehl in das Programm eingefgt:
*/
include_once "projektpfad.inc.php";

/*
 Die Ausgabekonstanten 'NEUESEITE' und 'LEERZEILE' befinden sich in einer
 Include-Datei und werden durch den nachfolgenden 'include'-Befehl in das
 Programm eingefgt:
*/
include_once PFAD . "ausgabesteuerungskonstante.inc.php";

/*
 Die Aufbereitung der Struktur fr den Eingabebereich befindet sich in einer
 Include-Datei und wird durch den nachfolgenden 'include'-Befehl in das
 Programm eingefgt:
*/
include_once PFAD . "prozeduraleSkripte/Includedateien/vertret.inc.php";

/*
 Die tatschlich verwendete Datei wird im 'fopen'-Befehl festgelegt.
 Um den Dateinamen und/oder den Pfad ndern zu knnnen (z.B. durch eine 
 Benutzereingabe), wird die folgende Variable 'EINGABEDATEI' definiert (der 
 Einfachheit halber wird der Dateiname mit dem Pfad jedoch fix vorgegeben):
*/
$EINGABEDATEI = PFAD . "DateienASCII/vertreter.dat";

/*
 Konstante fr die maximale Anzahl der Zeilen pro Seite (Zeilenzhlergrenze):
*/
const ZZG = 22;

/*
 Konstante fr den berschriftstext und das Ausgabeformat einer Zeile:
*/
const UEB = "<strong>LFDE.NR.  V E R T R E T E R N A M E     VERTRETERUMSATZ  NUMMER</strong><br />";
const F_AUS = " %6d   %s % 13.2f    %s<br />";

// Datenstruktur $ein
// Datenstruktur $aus

// int $rlf
// int $zz

/* -------------------------------------------------------------------------- */
$VERTRET = fopen($EINGABEDATEI, "rb") 
              or die("<p>Die Datei <b>$EINGABEDATEI</b> existiert nicht.</p>");

$zz = ZZG;
$rlf = 0;
$datensatz = fread($VERTRET, SATZLAENGE);
while (!feof($VERTRET))
{
    $ein = aufbereitenDatensatz($datensatz);
    $rlf = $rlf + 1;
    $aus->alf  = $rlf;
    $aus->anam = $ein->enam;
    $aus->aums = $ein->eums;
    $aus->anr  = $ein->enr;
    if ($zz >= ZZG)
    {
        printf(NEUESEITE);
        printf(UEB);
        printf(LEERZEILE);
        $zz = 2;
    }
    printf(F_AUS, $aus->alf, $aus->anam, $aus->aums, $aus->anr);
    $zz = $zz + 1;
    $datensatz = fread($VERTRET, SATZLAENGE);
}

fclose($VERTRET);

/* -------------------------------------------------------------------------- */
?>
</pre>

<p> </p><hr /><p> </p>

<address id="ende">
Copyright &#169; 2008<br />
Letzte Aktualisierung: 2010-02-01<br />
Beringer Alfred<br />
<a href="mailto:beringer@spengergasse.at">beringer@spengergasse.at</a>
</address>

</body>
</html>
