<!DOCTYPE html public "-//W3C//DTD XHTML 1.0 Transitional//EN"
                      "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<!-- Programm "a08.php" -->
<html>
<head>
<meta name="author"      content="Beringer Alfred" />
<meta name="description" content="Programmierlogik" />
<meta name="keywords"    content="Programmieren, Buch, Programmierlogik, PHP, Programme" />

<title>A08</title>
</head>
<body>

<pre>
<?php 
/*
 *******************************************************************************
 bung A08

 Klassenliste - Auswahl von Datenstzen und Datenfeldern,
                Konstante, Parameter, Literale.
 ---------------------------------------------------------------
 EINGABEDATEN: SCHLERDATEI
       AUFBAU:
         1 - 20 (20) ... FAMILIENNAME
        21 - 30 (10) ... VORNAME
           31   ( 1) ... GESCHLECHT
        32 - 39 ( 8) ... GEBURTSDATUM (IN DER FORM JJJJMMTT)
        40 - 41 ( 2) ... RELIGION (VERSCHLSSELT)
        42 - 44 ( 3) ... STAATSBRGERSCHAFT
        45 - 49 ( 5) ... KLASSE
        50 - 53 ( 4) ... POSTLEITZAHL
        54 - 65 (12) ... ORT
        66 - 80 (15) ... STRASSE
 ---------------------------------------------------------------
 AUSGABEDATEN: SCHLERLISTE FR DIE KLASSE 1BKDV
       AUFBAU:
         1 HAUPTBERSCHRIFT MIT DER AUSGEWHLTEN KLASSE
         1 LEERZEILE
         1 SPALTENBERSCHRIFT
         1 LEERZEILE
 
         1 ZEILE FR JEDEN SCHLER AUS DER KLASSE 1BKDV.
             JEDE ZEILE MIT
                LAUFENDER NUMMER
                FAMILIENNAME
                VORNAME
                GEBURTSDATUM (NUR BEI MNNLICHEN SCHLERN!)
 
 PRO SEITE MAXIMAL 22 ZEILEN (EINSCHL. BERSCHRIFT + LEERZEILE).
 DIE BERSCHRIFT SOLL NIE ALLEIN AUF EINER SEITE STEHEN.
 -------------------------------------------------------------------------------
 @module  Fachbuch "Programmierlogik"
 @since   August 2008
 @version August 2009
 @author  Beringer Alfred
 *******************************************************************************
*/

include_once "projektpfad.inc.php";

include_once PFAD . "ausgabesteuerungskonstante.inc.php";
include_once PFAD . "prozeduraleSkripte/Includedateien/schueler.inc.php";

//$EINGABEDATEI = PFAD . "DateienASCII/vormerk.dat";
$EINGABEDATEI = PFAD . "DateienASCII/schueler.dat";

const ZMAX = 22;

const ABUE = "<strong>        1BKDV   LFD.NUMMER  FAMILIENNAME         VORNAME     GEBURTSDATUM</strong><br />";
const F_AB = "                    %02d      %s %s    %s  <br />";

/*
 Programmparameter der Einfachheit halber als Konstante definieren 
 (damit knnen diese Konstante direkt in Funktionen verwendet werden):
*/
const VG  = 'M';
const VKL = "1BKDV";

// Datenstruktur $eb
// Datenstruktur $ab

// int $zz
// int $rlnr

/* -------------------------------------------------------------------------- */
$SCHULE = fopen($EINGABEDATEI, "rb") 
             or die("<p>Die Datei <b>$EINGABEDATEI</b> existiert nicht.</p>");

upstart($zz, $rlnr);
$datensatz = fread($SCHULE, SATZLAENGE);
while (!feof($SCHULE))
{
    $eb = aufbereitenDatensatz($datensatz);
    if ($eb->ekl == VKL)
        upva($eb, $rlnr, $zz);
    $datensatz = fread($SCHULE, SATZLAENGE);
}

fclose($SCHULE);
/* -------------------------------------------------------------------------- */

function upstart(&$zz, &$rlnr)
{
    $zz = ZMAX;
    $rlnr = 0;
} // -------------------------------------------- Ende upstart

function upva($eb, &$rlnr, &$zz)
{
    $ab = upaber($eb, $rlnr);
    upausgab($ab, $zz);
} // -------------------------------------------- Ende upva

function upaber($eb, &$rlnr)
{
    $rlnr++;
    $ab->alnr = $rlnr;
    $ab->afn = $eb->efn;
    $ab->avn = $eb->evn;
    if ($eb->eg == VG)
        $ab->agd = $eb->egd;
    else
        $ab->agd = str_pad("", strlen($eb->egd));
        
    return $ab;
} // -------------------------------------------- Ende upaber

function upausgab($ab, &$zz)
{
    upueb($zz);
    printf(F_AB, $ab->alnr, $ab->afn, $ab->avn, $ab->agd);
    $zz++;
} // -------------------------------------------- Ende upausgab

function upueb(&$zz)
{
    if ($zz >= ZMAX)
        upueber($zz);
} // -------------------------------------------- Ende upueb

function upueber(&$zz)
{
    printf(NEUESEITE);
    printf(ABUE);
    printf(LEERZEILE);
    $zz = 2;
} // -------------------------------------------- Ende upueber

/* -------------------------------------------------------------------------- */
?>
</pre>

<p> </p><hr /><p> </p>

<address id="ende">
Copyright &#169; 2008<br />
Letzte Aktualisierung: 2010-02-01<br />
Beringer Alfred<br />
<a href="mailto:beringer@spengergasse.at">beringer@spengergasse.at</a>
</address>

</body>
</html>
