<!DOCTYPE html public "-//W3C//DTD XHTML 1.0 Transitional//EN"
                      "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<!-- Programm "a12.php" -->
<html>
<head>
<meta name="author"      content="Beringer Alfred" />
<meta name="description" content="Programmierlogik" />
<meta name="keywords"    content="Programmieren, Buch, Programmierlogik, PHP, Programme" />

<title>A12</title>
</head>
<body>

<pre>
<?php 
/*
 *******************************************************************************
 bung A12

 Kundenstatistik - Inland/Ausland, Soll/Haben,
                   Fehlerprfungen.
 ---------------------------------------------------------------
 EINGABEDATEN: KUNDENDATEI
       AUFBAU:
         1 -  4 ( 4) ... KUNDENNUMMER
         5 - 24 (20) ... KUNDENNAME
           25   ( 1) ... SCHLSSEL ('1' = SOLL,
                                    '2' = HABEN)
        26 - 33 ( 8) ... UMSATZ (2 NACHKOMMASTELLEN)
           34   ( 1) ... SATZART ('1' = INLANDSUMSATZ,
                                  '2' = AUSLANDSUMSATZ)
 
 DIE EINGABEDATEN SIND NACH KUNDENNUMMERN AUFSTEIGEND SORTIERT.
 PRO SCHLSSEL UND SATZART GIBT ES MAXIMAL 100 DATENSTZE.
 ---------------------------------------------------------------
 AUSGABEDATEN: UMSATZLISTE
       AUFBAU:
         1 HAUPTBERSCHRIFT
         1 SPALTENBERSCHRIFT
         1 LEERZEILE
 
         1 ZEILE FR JEDEN KUNDEN MIT
             KUNDENNAME
             UMSATZ - IN ENTSPRECHENDER SPALTE
                         (JE NACH SATZART UND SCHLSSEL)
 
        AM ENDE DER VERARBEITUNG:
         1 LEERZEILE UND
         1 GESAMTSUMMENZEILE MIT DEN 4 SPALTENSUMMEN
 
 PRO SEITE MAXIMAL 22 ZEILEN
      (EINSCHL. BERSCHRIFTEN + LEERZEILEN),
      AUSGENOMMEN DIE LETZTE SEITE).
 DIE SUMMENZEILE SOLL NIE UNMITTELBAR AUF DIE 
      BERSCHRIFT FOLGEN.
 -------------------------------------------------------------------------------
 @module  Fachbuch "Programmierlogik"
 @since   August 2008
 @version August 2009
 @author  Beringer Alfred
 *******************************************************************************
*/

include_once "projektpfad.inc.php";

include_once PFAD . "ausgabesteuerungskonstante.inc.php";
include_once PFAD . "prozeduraleSkripte/Includedateien/kunden.inc.php";

$EINGABEDATEI = PFAD . "DateienASCII/kunden.dat";

const ZMAX = 22;

const ABU1   = "<strong>K U N D E N N A M E          I N L A N D            A U S L A N D   </strong><br />";
const ABU2   = "<strong>                           SOLL       HABEN        SOLL       HABEN </strong><br />";
const F_ABER = "%s  % 10.2f  % 10.2f  % 10.2f  % 10.2f<br />";
const F_ABS  = "                    % 12.2f% 12.2f% 12.2f% 12.2f<br />";
const F_KFEL = "%s %s<br />";

const FM1 = "SORTIERFOLGEFEHLER ";
const FM2 = "FALSCHER SCHLUESSEL";
const FM3 = "FALSCHE SATZART    ";

const LOW = "\x00\x00\x00\x00";

/*
 Programmparameter der Einfachheit halber als Konstante definieren 
 (damit knnen diese Konstante direkt in Funktionen verwendet werden):
*/
const VSOL = '1';
const VHAB = '2';
const VILD = '1';
const VALD = '2';

// Datenstruktur $eber
// Datenstruktur $aber
// Datenstruktur $abs
// Datenstruktur $kfel

// string(4+1) $nralt
// float       $sumis
// float       $sumih
// float       $sumas
// float       $sumah
// int         $zz

/* -------------------------------------------------------------------------- */
$KUNDEN = fopen($EINGABEDATEI, "rb") 
             or die("<p>Die Datei <b>$EINGABEDATEI</b> existiert nicht.</p>");

upstart($nralt, $zz, $sumis, $sumih, $sumas, $sumah);
$datensatz = fread($KUNDEN, SATZLAENGE);
while (!feof($KUNDEN))
{
    $eber = aufbereitenDatensatz($datensatz);
    if ($nralt >= $eber->enr)
    {
        $kfel->kfm = FM1;
        upfel($eber, $kfel, $zz);
    }
    else
        $nralt = $eber->enr;
    $aber->aisol = 0.0;
    $aber->aihab = 0.0;
    $aber->aasol = 0.0;
    $aber->aahab = 0.0;
    if ($eber->eschl == VSOL)
        if ($eber->esa == VILD)
        {
            $aber->aisol = $eber->eums;
            $sumis = $sumis + $eber->eums;
            upschr($eber, $aber, $zz);
        }
        else
            if ($eber->esa == VALD)
            {
                $aber->aasol = $eber->eums;
                $sumas = $sumas + $eber->eums;
                upschr($eber, $aber, $zz);
            }
            else
            {
                $kfel->kfm = FM3;
                upfel($eber, $kfel, $zz);
            }
    else
        if ($eber->eschl == VHAB)
            if ($eber->esa == VILD)
            {
                $aber->aihab = $eber->eums;
                $sumih = $sumih + $eber->eums;
                upschr($eber, $aber, $zz);
            }
            else
                if ($eber->esa == VALD)
                {
                    $aber->aahab = $eber->eums;
                    $sumah = $sumah + $eber->eums;
                    upschr($eber, $aber, $zz);
                }
                else
                {
                    $kfel->kfm = FM3;
                    upfel($eber, $kfel, $zz);
                }
        else
        {
            $kfel->kfm = FM2;
            upfel($eber, $kfel, $zz);
            if ($eber->esa == VILD) ;
            else
                if ($eber->esa == VALD) ;
                else
                {
                    $kfel->kfm = FM3;
                    upfel($eber, $kfel, $zz);
                }
        }
    $datensatz = fread($KUNDEN, SATZLAENGE);
}
upendva($sumis, $sumih, $sumas, $sumah);

fclose($KUNDEN);
/* -------------------------------------------------------------------------- */

function upstart($nralt, &$zz, &$sumis, &$sumih, &$sumas, &$sumah)
{
    $zz = ZMAX;
    $nralt = LOW;
    $sumis = 0.0;
    $sumih = 0.0;
    $sumas = 0.0;
    $sumah = 0.0;
} // -------------------------------------------- Ende upstart

function upendva($sumis, $sumih, $sumas, $sumah)
{
    printf(LEERZEILE);
    $abs->asumis = $sumis;
    $abs->asumih = $sumih;
    $abs->asumas = $sumas;
    $abs->asumah = $sumah;
    printf(F_ABS, $abs->asumis, $abs->asumih, $abs->asumas, $abs->asumah);
} // -------------------------------------------- Ende upendva

function upschr($eber, $aber, &$zz)
{
    $aber->anam = $eber->enam;
    if ($zz >= ZMAX)
        upueber($zz);
    printf(F_ABER, $aber->anam, $aber->aisol, $aber->aihab, $aber->aasol, $aber->aahab);
    $zz++;
} // -------------------------------------------- Ende upschr

function upueber(&$zz)
{
    printf(NEUESEITE);
    printf(ABU1);
    printf(ABU2);
    printf(LEERZEILE);
    $zz = 3;
} // -------------------------------------------- Ende upueber

function upfel($eber, $kfel, &$zz)
{
    $kfel->knr = $eber->enr;
    printf(F_KFEL, $kfel->knr, $kfel->kfm);
    $zz++;
} // -------------------------------------------- Ende upfel

/* -------------------------------------------------------------------------- */
?>
</pre>

<p> </p><hr /><p> </p>

<address id="ende">
Copyright &#169; 2008<br />
Letzte Aktualisierung: 2010-02-01<br />
Beringer Alfred<br />
<a href="mailto:beringer@spengergasse.at">beringer@spengergasse.at</a>
</address>

</body>
</html>
