<!DOCTYPE html public "-//W3C//DTD XHTML 1.0 Transitional//EN"
                      "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<!-- Programm "a36.php" -->
<html>
<head>
<meta name="author"      content="Beringer Alfred" />
<meta name="description" content="Programmierlogik" />
<meta name="keywords"    content="Programmieren, Buch, Programmierlogik, PHP, Programme" />

<title>A36</title>
</head>
<body>

<pre>
<?php 
/*
 *******************************************************************************
 bung A36

 Umsatzstatistik - eindimensionale Tabelle (Monat).
 ---------------------------------------------------------------
 EINGABEDATEN: VERTRETERUMSATZDATEI
       AUFBAU:
         1 -  2 ( 2) ... VERTRETERNUMMER (01 - 15)
         3 -  4 ( 2) ... MONAT (01 - 12)
         5 - 12 ( 8) ... VERTRETERUMSATZ (2 NACHKOMMASTELLEN)
 
 DIE REIHENFOLGE DER DATEN IST UNBESTIMMT.
 ---------------------------------------------------------------
 AUSGABEDATEN: JAHRESUMSATZSTATISTIKLISTE
       AUFBAU:
         1 HAUPTBERSCHRIFT
         1 LEERZEILE
         1 SPALTENBERSCHRIFT
         1 LEERZEILE
 
         1 ZEILE PRO MONAT MIT
             MONATSNUMMER
             MONATSUMSATZ
 
         1 LEERZEILE UND
         1 GESAMTSUMMENZEILE MIT
             JAHRESUMSATZ
 -------------------------------------------------------------------------------
 @module  Fachbuch "Programmierlogik"
 @since   August 2008
 @version August 2009
 @author  Beringer Alfred
 *******************************************************************************
*/

include_once "projektpfad.inc.php";

include_once PFAD . "ausgabesteuerungskonstante.inc.php";
include_once PFAD . "prozeduraleSkripte/Includedateien/vertretA3637.inc.php";

$EINGABEDATEI = PFAD . "DateienASCII/vertreterA3637.dat";

const ABUE1   = "<strong>            JAHRESUMSATZSTATISTIK </strong><br />";
const ABUE2   = "<strong>          MONAT              UMSATZ </strong><br />";
const F_AB    = "            %02d           % 10.2f<br />";
const F_ABL   = "          SUMME        % 12.2f<br />";
const F_ABFEL = "FALSCHER MONAT:   %6d  %6d  % 10.2f<br />";

// Datenstruktur $eb
// Datenstruktur $ab
// Datenstruktur $abl

$tsum = array( 1=>0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 );

/* -------------------------------------------------------------------------- */
$VERTRET = fopen($EINGABEDATEI, "rb") 
              or die("<p>Die Datei <b>$EINGABEDATEI</b> existiert nicht.</p>");

$datensatz = fread($VERTRET, SATZLAENGE);
while (!feof($VERTRET))
{
    $eb = aufbereitenDatensatz($datensatz);
    upva($eb, $tsum);
    $datensatz = fread($VERTRET, SATZLAENGE);
}
uprognach($tsum);

fclose($VERTRET);
/* -------------------------------------------------------------------------- */

function upva($eb, &$tsum)
{
    $rmonat = $eb->emonat;
    if ($rmonat < 1)
        upf($eb);
    else
        if ($rmonat <= count($tsum))
        {
            $tsum[$rmonat] += $eb->eums;
        }
        else
            upf($eb);
} // -------------------------------------------- Ende upva

function uprognach($tsum)
{
// short $rmonat
// float $gsum

    upueb();
    $gsum = 0.0;
    $rmonat = 1;
    while ($rmonat <= count($tsum))
    {
        $ab->amonat = $rmonat;
        $ab->asum = $tsum[$rmonat];
        printf(F_AB, $ab->amonat, $ab->asum);
        $gsum += $tsum[$rmonat];
        $rmonat++;
    }
    printf(LEERZEILE);
    $abl->agsum = $gsum;
    printf(F_ABL, $abl->agsum);
} // -------------------------------------------- Ende uprognach

function upueb()
{
    printf(NEUESEITE);
    printf(ABUE1);
    printf(LEERZEILE);
    printf(ABUE2);
    printf(LEERZEILE);
} // -------------------------------------------- Ende upueb

function upf($eb)
{
  printf(F_ABFEL, $eb->evnr, $eb->emonat, $eb->eums);
} // -------------------------------------------- Ende upf

/* -------------------------------------------------------------------------- */
?>
</pre>

<p> </p><hr /><p> </p>

<address id="ende">
Copyright &#169; 2008<br />
Letzte Aktualisierung: 2010-02-01<br />
Beringer Alfred<br />
<a href="mailto:beringer@spengergasse.at">beringer@spengergasse.at</a>
</address>

</body>
</html>
