<!DOCTYPE html public "-//W3C//DTD XHTML 1.0 Transitional//EN"
                      "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<!-- Programm "a38.php" -->
<html>
<head>
<meta name="author"      content="Beringer Alfred" />
<meta name="description" content="Programmierlogik" />
<meta name="keywords"    content="Programmieren, Buch, Programmierlogik, PHP, Programme" />

<title>A38</title>
</head>
<body>

<pre>
<?php 
/*
 *******************************************************************************
 bung A38

 Theaterliste - Sortierfolge, zweifacher Gruppenwechsel + eindimensionale Tabelle.
 ---------------------------------------------------------------
 EINGABEDATEN: THEATERDATEI
       AUFBAU:
           1     ( 1) ... KENNZIFFER FR SPIELORT
                             (ES GIBT 8 SPIELORTE)
         2 -  40 (39) ... TITEL DES THEATERSTCKS
        41 -  60 (20) ... NAME DES SCHAUSPIELERS
        61 -  75 (15) ... STAMMTHEATER DES SCHAUSPIELERS
           76    ( 1) ... GEHALTSKATEGORIE
        77 -  80 ( 4) ... GEHALTSZUSCHLAG (2 NACHKOMMASTELLEN)
        81 - 103 (23) ... ROLLE (DES SCHAUSPIELERS IM STCK)
       104 - 111 ( 8) ... PREMIERENDATUM IN DER FORM JJJJMMTT
       112 - 119 ( 8) ... LETZTER SPIELTAG IN FORM JJJJMMTT
 
 DIE EINGABEDATEN SIND AUFSTEIGEND SORTIERT NACH DEM
     STAMMTHEATER,
        INNERHALB EINES STAMMTHEATERS NACH DEM
     NAMEN DES SCHAUSPIELERS,
        INNERHALB DES SCHAUSPIELERNAMENS NACH DEM
     TITEL DES THEATERSTCKS
        UND INNERHALB DES THEATERSTCKS NACH DER
     ROLLE DES SCHAUSPIELERS.
 ---------------------------------------------------------------
 AUSGABEDATEN: ROLLENLISTE
       AUFBAU:
         1 SPALTENBERSCHRIFT UND
         1 LEERZEILE
 
    PRO THEATER - BEGINNEND AUF EINER NEUEN SEITE - FR JEDEN
    SEINER STAMMSPIELER PRO SPIELORT, IN DEM DIESER SCHAUSPIELER
    ZUMINDEST EINMAL 1 ROLLE GESPIELT HAT, 1 ZEILE MIT:
             STAMMTHEATER
             NAME DES SCHAUSPIELERS
             SPIELORT
             ANZAHL DER ROLLEN, DIE DER SCHAUSPIELER AM
                           SPIELORT GESPIELT HAT
 
    PRO STAMMTHEATER 1 SUMMENZEILE MIT:
             ANZAHL SEINER SCHAUSPIELER
 
    AM ENDE DER VERARBEITUNG 1 GESAMTSUMMENZEILE MIT:
             GESAMTANZAHL ALLER SCHAUSPIELER
 
 PRO SEITE MAXIMAL 20 ZEILEN
      (EINSCHL. BERSCHRIFT + LEERZEILE).
 DIE BERSCHRIFT SOLL NIE ALLEIN AUF EINER SEITE STEHEN.
 -------------------------------------------------------------------------------
 @module  Fachbuch "Programmierlogik"
 @since   August 2008
 @version August 2009
 @author  Beringer Alfred
 *******************************************************************************
*/

include_once "projektpfad.inc.php";

include_once PFAD . "ausgabesteuerungskonstante.inc.php";
include_once PFAD . "prozeduraleSkripte/Includedateien/theater.inc.php";

$EINGABEDATEI = PFAD . "DateienASCII/theater.dat";

const HIGH = "\xff";
const LOW  = "\x00";

//const L0LEN =  1;
//const L1LEN = 16;
//const L2LEN = 36;

const ZZMAX = 20;

const ABUE    = "<strong>STAMMTHEATER       SCHAUSPIELER            SPIELORT        ANZAHL ROLLEN</strong><br />";
const F_ABL2  = "%s    %s    %s      %2d <br />";
const F_ABL1  = "%s HAT  %3d  SCHAUSPIELER. <br />";
const F_ABL0  = "            ES GIBT %4d  SCHAUSPIELER IN WIEN. <br />";
const F_ABFEL = "FALSCHES KENNZEICHEN: %s  %s  %s<br />";

const ANZKENNZ = 8;

// Datenstruktur $eber
// Datenstruktur $el,
//               $vl 
// Datenstruktur $abl2
// Datenstruktur $abl1
// Datenstruktur $abl0

// int $suml0
// int $suml1
// int $tsuml2[ANZKENNZ]
// int $zz

$tort = array( 1=>"STAATSOPER     ",
                  "VOLKSOPER      ",
                  "KAMMEROPER     ",
                  "BURGTHEATER    ",
                  "RAIMUNDTHEATER ",
                  "JOSEFSTADT     ",
                  "KAMMERSPIELE   ",
                  "VOLKSTHEATER   " );

/* -------------------------------------------------------------------------- */
$THEATER = fopen($EINGABEDATEI, "rb") 
              or die("<p>Die Datei <b>$EINGABEDATEI</b> existiert nicht.</p>");

uprogvb($el, $vl, $suml0);
uplesen($THEATER, $eb, $el);
while ($el->eof == $vl->eof)
{
    uphgvb($eb, $el, $vl, $abl1, $abl2, $suml1, $zz);
    while ($el->eof == $vl->eof 
              && $el->gst1 == $vl->gst1)
    {
        upgrvb($eb, $el, $vl, $abl2, $tsuml2);
        while ($el->eof == $vl->eof 
                  && $el->gst1 == $vl->gst1 
                        && $el->gst2 == $vl->gst2)
        {
            upeinzel($eb, $tsuml2);
            uplesen($THEATER, $eb, $el);
        }
        upgrnb($abl2, $tort, $tsuml2, $suml1, $zz, $vl);
    }
    uphgnb($abl1, $suml1, $suml0);
}
uprognb($abl0, $suml0);

fclose($THEATER);
/* -------------------------------------------------------------------------- */

function uplesen(&$datei, &$eb, &$el)
{
    $datensatz = fread($datei, SATZLAENGE);
    if (feof($datei))
        $el->eof = HIGH;
    else
    {
        $eb = aufbereitenDatensatz($datensatz);
        $el->gst1 = $eb->estamm;
        $el->gst2 = $eb->ename;
    }
} // -------------------------------------------- Ende uplesen

function uprogvb(&$el, &$vl, &$suml0)
{
  $el->eof = LOW;
  $suml0 = 0;
  $vl->eof = $el->eof;
} // -------------------------------------------- Ende uprogvb

function uphgvb($eb, $el, &$vl, &$abl1, &$abl2, &$suml1, &$zz)
{
    $zz = ZZMAX;
    $abl2->astamml2 = $eb->estamm;
    $abl1->astamml1 = $eb->estamm;
    $suml1 = 0;
    $vl->gst1 = $el->gst1;
} // -------------------------------------------- Ende uphgvb

function upgrvb($eb, $el, &$vl, &$abl2, &$tsuml2)
{
    $rkennz = 1;
    while ($rkennz <= ANZKENNZ)
    {
        $tsuml2[$rkennz] = 0;
        $rkennz++;
    }
    $abl2->anamel2 = $eb->ename;
    $vl->gst2 = $el->gst2;
} // -------------------------------------------- Ende upgrvb

function upeinzel($eb, &$tsuml2)
{
  $rkennz = $eb->ekennz;
  if (settype($rkennz, "integer") == FALSE)
  {
      upf($eb);
      return;
  }
  if ($rkennz < 1)
  {
      upf($eb);
      return;
  }
  if ($rkennz > ANZKENNZ)
  {
      upf($eb);
      return;
  }

  $tsuml2[$rkennz]++;
} // -------------------------------------------- Ende upeinzel

function upgrnb(&$abl2, $tort, $tsuml2, &$suml1, &$zz, $vl)
{
    $rkennz = 1;
    while ($rkennz <= ANZKENNZ)
    {
        if ($tsuml2[$rkennz] != 0)
        {
            $abl2->aortl2 = $tort[$rkennz];
            $abl2->asuml2 = $tsuml2[$rkennz];
            upschr($abl2, $zz, $vl);
        }
        $rkennz++;
    }
    printf(LEERZEILE);
    $zz++;
    $suml1++;
} // -------------------------------------------- Ende upgrnb

function uphgnb(&$abl1, $suml1, &$suml0)
{
    $abl1->asuml1 = $suml1;
    printf(F_ABL1, $abl1->astamml1, $abl1->asuml1);
    $suml0 = $suml0 + $suml1;
} // -------------------------------------------- Ende uphgnb

function uprognb(&$abl0, $suml0)
{
    printf(LEERZEILE);
    $abl0->asuml0 = $suml0;
    printf(F_ABL0, $abl0->asuml0);
} // -------------------------------------------- Ende uprognb

function upschr(&$abl2, &$zz, $vl)
{
    if ($zz >= ZZMAX)
        upueber($abl2, $zz, $vl);
    printf(F_ABL2, $abl2->astamml2, $abl2->anamel2, $abl2->aortl2, $abl2->asuml2);
    $zz++;
    $abl2->astamml2 = str_pad("", strlen($abl2->astamml2));
    $abl2->anamel2  = str_pad("", strlen($abl2->anamel2));
} /// -------------------------------------------- Ende upschr

function upueber(&$abl2, &$zz, $vl)
{
  printf(NEUESEITE);
  printf(ABUE);
  printf(LEERZEILE);
  $zz = 2;
  $abl2->astamml2 = $vl->gst1;
  $abl2->anamel2  = $vl->gst2;
} // -------------------------------------------- Ende upueber

function upf($eber)
{
  printf(F_ABFEL, $eber->ekennz, $eber->ename, $eber->estamm);
} // -------------------------------------------- Ende upf

/* -------------------------------------------------------------------------- */
?>
</pre>

<p> </p><hr /><p> </p>

<address id="ende">
Copyright &#169; 2008<br />
Letzte Aktualisierung: 2010-02-01<br />
Beringer Alfred<br />
<a href="mailto:beringer@spengergasse.at">beringer@spengergasse.at</a>
</address>

</body>
</html>
