<!DOCTYPE html public "-//W3C//DTD XHTML 1.0 Transitional//EN"
                      "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<!-- Programm "a39.php" -->
<html>
<head>
<meta name="author"      content="Beringer Alfred" />
<meta name="description" content="Programmierlogik" />
<meta name="keywords"    content="Programmieren, Buch, Programmierlogik, PHP, Programme" />

<title>A39</title>
</head>
<body>

<pre>
<?php 
/*
 *******************************************************************************
 bung A39 (Version 1)

 Mischlogik - Artikelstze ndern.
 ---------------------------------------------------------------
 EINGABEDATEN: ARTIKELDATEI
       AUFBAU:
         1 -  4 ( 4) ... ARTIKELNUMMER
         5 - 24 (20) ... ARTIKELBEZEICHNUNG
        25 - 31 ( 7) ... EINZELPREIS
        32 - 36 ( 5) ... BESTANDSMENGE
        37 - 55 (19) ... SONSTIGE DATEN
 
 EINGABEDATEN: NDERUNGSDATEI
       AUFBAU:
         1 -  4 ( 4) ... ARTIKELNUMMER
         5 - 11 ( 7) ... NEUER EINZELPREIS
 
 BEIDE DATEIEN SIND AUFSTEIGEND SORTIERT NACH DER
 ARTIKELNUMMER.
 PRO ARTIKELNUMMER GIBT ES NUR 1 EINGABEDATENSATZ.
 ---------------------------------------------------------------
 AUSGABEDATEN: AKTUALISIERTE ARTIKELDATEI
 
               FEHLERPROTOKOLL
                      ZU NDERNDE ARTIKELNUMMER NICHT VORHANDEN
                      SORTIERFOLGEFEHELER IN DER NDERUNGSDATEI
 -------------------------------------------------------------------------------
 @module  Fachbuch "Programmierlogik"
 @since   August 2008
 @version August 2009
 @author  Beringer Alfred
 *******************************************************************************
*/

include_once "projektpfad.inc.php";

include_once PFAD . "ausgabesteuerungskonstante.inc.php";
include_once PFAD . "prozeduraleSkripte/Includedateien/artikel.inc.php";
include_once PFAD . "prozeduraleSkripte/Includedateien/kaender.inc.php";

$DATEIALT = PFAD . "DateienASCII/artikel.dat";
$DATEINEU = PFAD . "DateienASCII/NEUBAND.dat";
$DATEI    = PFAD . "DateienASCII/kaender.dat";

const HIGH = "\xff\xff\xff\xff";

const ZZGF = 22;

const FUEB   = "<strong>FEHLERPROTOKOLL</strong><br />";
const F_FBER = "%s %s<br />";
const FEHL1  = "ARTIKEL NICHT VORHANDEN       ";

// Datenstruktur $bber
// Datenstruktur $kber
// Datenstruktur $fber

// int $eofz

$zzf = 99;

/* -------------------------------------------------------------------------- */
$ALTBAND = fopen($DATEIALT, "rb") 
              or die("<p>Die Datei <b>$DATEIALT</b> existiert nicht.</p>");
$NEUBAND = fopen($DATEINEU,"wb")
              or die("<p>Sie k&ouml;nnen die Datei <b>$DATEINEU</b> leider nicht erstellen.</p>");
$KAENDER = fopen($DATEI, "rb") 
              or die("<p>Die Datei <b>$DATEI</b> existiert nicht.</p>");

$eofz = 0;
uplesaltband($ALTBAND, $eofz, $bber);
upleskaender($KAENDER, $eofz, $kber);
while ($eofz < 2)
{
    if ($bber->bnr < $kber->knr)
    {
        $str = toStringAltband($bber);
        fwrite($NEUBAND, $str, SATZLAENGEALTBAND);
        uplesaltband($ALTBAND, $eofz, $bber);
    }
    else
        if ($bber->bnr == $kber->knr)
        {
            $bber->bpreis = $kber->kpreis;
            $str = toStringAltband($bber);
            fwrite($NEUBAND, $str, SATZLAENGEALTBAND);
            uplesaltband($ALTBAND, $eofz, $bber);
            upleskaender($KAENDER, $eofz, $kber);
        }
        else
        {
            $fber->fmeld = FEHL1;
            upschrf($zzf, $fber, $kber);
            upleskaender($KAENDER, $eofz, $kber);
        }
}

fclose($ALTBAND);
fclose($NEUBAND);
fclose($KAENDER);
/* -------------------------------------------------------------------------- */

function uplesaltband(&$datei, &$eofz, &$bber)
{
    $datensatz = fread($datei, SATZLAENGEALTBAND);
    if (feof($datei))
    {
        $bber->bnr = HIGH;
        $eofz++;
    }
    else
    {
        $bber = aufbereitenDatensatzAltband($datensatz);
    }
} // -------------------------------------------- Ende uplesaltband

function upleskaender(&$datei, &$eofz, &$kber)
{
    $datensatz = fread($datei, SATZLAENGEKAENDER);
    if (feof($datei))
    {
        $kber->knr = HIGH;
        $eofz++;
    }
    else
    {
        $kber = aufbereitenDatensatzKaender($datensatz);
    }
} // -------------------------------------------- Ende upleskaender

function upschrf(&$zzf, &$fber, $kber)
{
    $fber->fnr = $kber->knr;
    if ($zzf >= ZZGF)
    {
        printf(NEUESEITE);
        printf(FUEB);
        printf(LEERZEILE);
        $zzf = 2;
    }
    printf(F_FBER, $fber->fnr, $fber->fmeld);
    $zzf++;
} // -------------------------------------------- Ende upschrf

/* -------------------------------------------------------------------------- */
?>
</pre>

<p> </p><hr /><p> </p>

<address id="ende">
Copyright &#169; 2008<br />
Letzte Aktualisierung: 2010-02-01<br />
Beringer Alfred<br />
<a href="mailto:beringer@spengergasse.at">beringer@spengergasse.at</a>
</address>

</body>
</html>
